/*!
 * 
 * SpreadJS Library 14.1.0
 * 
 * Copyright(c) GrapeCity, Inc.  All rights reserved.
 * 
 * Licensed under the SpreadJS Commercial License.
 * us.sales@grapecity.com
 * http://www.grapecity.com/en/licensing/grapecity/
 * 
 * 
 */

(function (factory) {
   if(typeof module === 'object' && typeof module.exports === 'object') {
       module.exports = factory(require('@grapecity/spread-sheets'));
   } else if(typeof define === 'function' && define.amd) {
       define(['@grapecity/spread-sheets'], factory)
   } else if(typeof exports === 'object') {
       exports['Spread'] = factory(require('@grapecity/spread-sheets'));
   } else {
       factory(GC);
   }
}(function (GC) {
GC = typeof GC === "object" ? GC : {}; GC["Spread"] = GC["Spread"] || {}; GC["Spread"]["Sheets"] = GC["Spread"]["Sheets"] || {}; GC["Spread"]["Sheets"]["Print"] =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/assets/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./dist/plugins/print/print.entry.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./dist/plugins/print/print.entry.js":
/*!*******************************************!*\
  !*** ./dist/plugins/print/print.entry.js ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(/*! ./print */ "./dist/plugins/print/print.js"));
__export(__webpack_require__(/*! ./print.ns */ "./dist/plugins/print/print.ns.js"));


/***/ }),

/***/ "./dist/plugins/print/print.js":
/*!*************************************!*\
  !*** ./dist/plugins/print/print.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });






var Common_1 = __webpack_require__(/*! Common */ "Common");
var Core_1 = __webpack_require__(/*! Core */ "Core");
var print_ns_1 = __webpack_require__(/*! ./print.ns */ "./dist/plugins/print/print.ns.js");
var CoreModule = __webpack_require__(/*! Core */ "Core");
var $ = CoreModule.GC$;
var Types = Common_1.Common._Types, isNullOrUndefined = Types._isNullOrUndefined;
var $_extend = $.extend, $_each = $.each, Sheets_util_browser = Core_1._util._browser, _applyBlackAndWhite = Core_1._util._applyBlackAndWhite;
var Math_sqrt = Math.sqrt, Math_pow = Math.pow;
var str_firstPageNumber = 'firstPageNumber', str_margin = 'margin', str_paperSize = 'paperSize', str_pageBreak = 'pageBreak', str_empty = '', str_printPage = 'gc-printPage', str_rowStart = 'rowStart', str_rowEnd = 'rowEnd', str_columnStart = 'columnStart', str_columnEnd = 'columnEnd', str_2d = '2d', str_px = 'px', str_div = 'div', str_canvas = 'canvas', keyword_null = null, Math_min = Math.min, Math_max = Math.max, Math_floor = Math.floor, parseIntFn = parseInt, parseFloatFn = parseFloat, JSON_stringify = JSON.stringify, JSON_parse = JSON.parse, GC_PRINTLINE_NS = '.GCPrintLine';
function isInteger(obj) {
    return typeof obj === 'number' && obj % 1 === 0;
}
function isInvalidValue(value) {
    return isNullOrUndefined(value) || value < 0;
}
var rm = new Common_1.Common.ResourceManager(print_ns_1.SR);
var getSR = rm.getResource.bind(rm);

$_extend(Core_1.Worksheet.prototype, {
   
    
    printInfo: function (value) {
        var self = this, returnValue;
        if (arguments.length === 0) {
            if (!self._printInfo) {
                self._printInfo = new PrintInfo(self);
            }
            returnValue = self._printInfo;
        }
        else {
            self._printInfo = value;
            if (!value._sheet) {
                value._sheet = self;
            }
            returnValue = self;
        }
        return returnValue;
    },
   
    
    getRowPageBreak: function (row) {
        return this._modelManager.getPageBreak(true, 3 , row);
    },
   
    
    setRowPageBreak: function (row, value) {
        this._setRowColInfo(row, value, str_pageBreak, true);
        if (this.isPrintLineVisible()) {
            this.repaint();
        }
    },
   
    
    getColumnPageBreak: function (column) {
        return this._modelManager.getPageBreak(false, 3 , column);
    },
   
    
    setColumnPageBreak: function (column, value) {
        this._setRowColInfo(column, value, str_pageBreak, false);
        if (this.isPrintLineVisible()) {
            this.repaint();
        }
    },
   
    
    isPrintLineVisible: function (value) {
        if (value === undefined) {
            return this._isShowPrintLine || false;
        }
        else if (this._isShowPrintLine === value) {
            return;
        }
        this._isShowPrintLine = value;
        this.repaint();
    },
    _getAllRowPageBreaks: function () {
        var axisModel = this._modelManager._getAxisModel(true, 3);
        var infos = axisModel && axisModel.infos;
        var result = [];
        if (infos) {
            for (var i = 0; i < infos.length; i++) {
                var item = infos[i];
                if (item && item.pageBreak) {
                    result.push(i);
                }
            }
        }
        return result;
    },
    _getAllColumnPageBreaks: function () {
        var axisModel = this._modelManager._getAxisModel(false, 3);
        var infos = axisModel && axisModel.infos;
        var result = [];
        if (infos) {
            for (var i = 0; i < infos.length; i++) {
                var item = infos[i];
                if (item && item.pageBreak) {
                    result.push(i);
                }
            }
        }
        return result;
    }
});
function getHeight(obj) {
    return obj.height;
}
function getWidth(obj) {
    return obj.width;
}
function createRowLayoutCache(rowLayout) {
    var cache = {};
    rowLayout.forEach(function (item) {
        cache[item.row] = item.y;
    });
    return cache;
}
function createColumnLayoutCache(columnLayout) {
    var cache = {};
    columnLayout.forEach(function (item) {
        cache[item.col] = item.x;
    });
    return cache;
}
var dashedLine =  (function () {
    function dashedLine(x0, y0, x1, y1, color, width, pattern) {
        var isSnapToPixel = width % 2;
        if (isSnapToPixel) {
            if (x0 !== x1) {
                y0 -= 0.5;
                y1 -= 0.5;
            }
            else {
                x0 -= 0.5;
                x1 -= 0.5;
            }
        }
        var self = this;
        self.x0 = x0;
        self.y0 = y0;
        self.x1 = x1;
        self.y1 = y1;
        self.color = color;
        self.lineWidth = width;
        self.pattern = pattern;
    }
    dashedLine.prototype.paintLine = function (ctx) {
        var self = this;
        var x0 = self.x0, x1 = self.x1, y0 = self.y0, y1 = self.y1;
        var length = Math_sqrt(Math_pow(x1 - x0, 2) + Math_pow(y1 - y0, 2));
        var vector = {
            x: (x1 - x0) / length,
            y: (y1 - y0) / length
        };
        var dist = 0, i = 0, pattern = self.pattern;
        pattern = pattern && pattern.length ? pattern : [4, 2];
        var pointArray = [{ x0: x0, y0: y0 }];
        while (dist < length) {
            var dashLength = Math_min(pattern[i % pattern.length], length - dist);
            i++;
            dist += dashLength;
            x0 += dashLength * vector.x;
            y0 += dashLength * vector.y;
            pointArray.push({ x0: x0, y0: y0 });
        }
        var xStart, xEnd, yStart, yEnd;
        ctx.save();
        ctx.beginPath();
        ctx.lineWidth = self.lineWidth;
        ctx.strokeStyle = self.color[0];
        for (i = 0; i < pointArray.length - 1; i += 2) {
            xStart = pointArray[i].x0;
            yStart = pointArray[i].y0;
            xEnd = pointArray[i + 1].x0;
            yEnd = pointArray[i + 1].y0;
            ctx.moveTo(xStart, yStart);
            ctx.lineTo(xEnd, yEnd);
        }
        ctx.stroke();
        ctx.restore();
        ctx.save();
        ctx.beginPath();
        ctx.lineWidth = self.lineWidth;
        ctx.strokeStyle = self.color[1];
        for (i = 1; i < pointArray.length - 1; i += 2) {
            xStart = pointArray[i].x0;
            yStart = pointArray[i].y0;
            xEnd = pointArray[i + 1].x0;
            yEnd = pointArray[i + 1].y0;
            ctx.moveTo(xStart, yStart);
            ctx.lineTo(xEnd, yEnd);
        }
        ctx.stroke();
        ctx.restore();
    };
    return dashedLine;
}());
function drawLine(ctx, x, y, width, height) {
    var lineWidth = ctx.lineWidth;
    var isSnapToPixel = lineWidth % 2;
    if (isSnapToPixel) {
        if (width === 0) {
            x -= 0.5;
            y -= 1;
            height += 1;
        }
        else {
            y -= 0.5;
            x -= 1;
            width += 1;
        }
    }
    ctx.moveTo(x, y);
    ctx.lineTo(x + width, y + height);
}
function paintPrintPreviewLine(ctx, columns, rows, columnLayoutCache, rowLayoutCache, colHeaderHeight, rowHeaderWidth, sheetLayout_height, sheetLayout_width) {
    for (var i = 0; i < columns.length; i++) {
        var column1 = columns[i] + 1;
        var x = columnLayoutCache[column1];
        if (x) {
            var dastedLine = new dashedLine(x, colHeaderHeight, x, sheetLayout_height, ['#9f9f9f', '#ffffff'], 1, [4, 2]);
            dastedLine.paintLine(ctx);
        }
    }
    for (var j = 0; j < rows.length; j++) {
        var row1 = rows[j] + 1;
        var y = rowLayoutCache[row1];
        if (y) {
            var dastedLine1 = new dashedLine(rowHeaderWidth, y, sheetLayout_width, y, ['#9f9f9f', '#ffffff'], 1, [4, 2]);
            dastedLine1.paintLine(ctx);
        }
    }
}
function paintPreviewPageLayout(ctx, columnStart, rowStart, columnEnd, rowEnd, startX, startY, rowHeaderWidth, colHeaderHeight, height, width) {
   
    ctx.save();
    ctx.beginPath();
    ctx.lineWidth = 1;
    ctx.strokeStyle = 'blue';
    if (columnStart !== -1 && startX !== rowHeaderWidth) {
        drawLine(ctx, startX, startY, 0, height) ;
    }
    if (rowStart !== -1 && startY !== colHeaderHeight) {
        drawLine(ctx, startX, startY, width, 0) ;
    }
    if (columnEnd !== -1 && (startX + width) !== rowHeaderWidth) {
        drawLine(ctx, startX + width, startY, 0, height) ;
    }
    if (rowEnd !== -1 && (startY + height) !== colHeaderHeight) {
        drawLine(ctx, startX, startY + height, width, 0) ;
    }
    ctx.stroke();
    ctx.restore();
}
function paintPreviewPageBreakLines(ctx, sheet, rowLayoutCache, columnLayoutCache, viewportRect) {
    ctx.save();
    ctx.beginPath();
    ctx.lineWidth = 1;
    ctx.strokeStyle = '#000000';
    var rowPageBreaks = sheet._getAllRowPageBreaks() || [];
    var columnPageBreaks = sheet._getAllColumnPageBreaks() || [];
    var index;
    for (index = 0; index < rowPageBreaks.length; index++) {
        var rowIndex = rowPageBreaks[index];
        var y = rowLayoutCache[rowIndex];
        if (y) {
            drawLine(ctx, viewportRect.x, y, getWidth(viewportRect), 0);
        }
    }
    for (index = 0; index < columnPageBreaks.length; index++) {
        var columnIndex = columnPageBreaks[index];
        var x = columnLayoutCache[columnIndex];
        if (x) {
            drawLine(ctx, x, viewportRect.y, 0, getHeight(viewportRect));
        }
    }
    ctx.stroke();
    ctx.restore();
}
Core_1.Worksheet._registerFeature('print', {
    toJson: function (data) {
        var printInfo = this._printInfo;
        if (printInfo) {
            var dataDic = printInfo.toJSON();
           
           
            var rowStart = dataDic[str_rowStart], rowEnd = dataDic[str_rowEnd];
            if (isInvalidValue(rowStart) && !isInvalidValue(rowEnd)) {
                dataDic[str_rowStart] = 0;
            }
            else if (!isInvalidValue(rowStart) && isInvalidValue(rowEnd)) {
                dataDic[str_rowEnd] = this.getRowCount();
            }
           
            var columnStart = dataDic[str_columnStart], columnEnd = dataDic[str_columnEnd];
            if (isInvalidValue(columnStart) && !isInvalidValue(columnEnd)) {
                dataDic[str_columnStart] = 0;
            }
            else if (!isInvalidValue(columnStart) && isInvalidValue(columnEnd)) {
                dataDic[str_columnEnd] = this.getColumnCount();
            }
            data.printInfo = dataDic;
        }
    },
    fromJson: function (data) {
        var printInfo = data && data.printInfo;
        if (printInfo) {
            this.printInfo().fromJSON(printInfo);
        }
    },
    paintSheetEnd: function (argus) {
        var self = this, clipRect = argus.clipRect;
        if (!self._isShowPrintLine || !clipRect) {
            return;
        }
        var workbook = self.parent;
        if (workbook._isPrintWorkbook === true) {
            return;
        }
        workbook._isPrintWorkbook = true;
        var activeSheetIndex = _getActiveWorksheetIndex(workbook);
        var sheet = _getActiveWorksheet(workbook);
        var printInfo = sheet.printInfo();
        var oldUseMax = printInfo.useMax();
        printInfo._useMax = false;
        var printLine = workbook._getPrintLine();
        var newWorkbook = printLine._attachContext(workbook, activeSheetIndex);
        var pageInfo = printLine.pageInfo(workbook, newWorkbook, activeSheetIndex, true);
        printInfo._useMax = oldUseMax;
        var columns = pageInfo.columns, rows = pageInfo.rows;
        var sheetLayout = self._getSheetLayout();
        var ctx = argus.ctx;
        for (var r = 0; r <= 2; r++) {
            for (var c = 0; c <= 2; c++) {
                var viewportRect = sheetLayout._viewportRect(r, c);
                viewportRect = self._render._getClipRect(r, c, viewportRect);
                if (viewportRect) {
                    var intersectRect = viewportRect.getIntersectRect(clipRect);
                    if (intersectRect) {
                        var sheetLayout_width = getWidth(sheetLayout), sheetLayout_height = getHeight(sheetLayout), rowLayout = self._getRowLayout(r), columnLayout = self._getColumnLayout(c), rowLayoutCache = createRowLayoutCache(rowLayout), columnLayoutCache = createColumnLayoutCache(columnLayout), lastRowLayout = rowLayout[rowLayout.length - 1], lastColumnLayout = columnLayout[columnLayout.length - 1];
                        sheetLayout_height = Math_min(lastRowLayout.y + lastRowLayout.height, sheetLayout_height);
                        sheetLayout_width = Math_min(lastColumnLayout.x + lastColumnLayout.width, sheetLayout_width);
                        var colHeaderHeight = sheetLayout._colHeaderHeight, rowHeaderWidth = sheetLayout._rowHeaderWidth;
                        var columnStart = printInfo.columnStart(), columnEnd = printInfo.columnEnd(), rowStart = printInfo.rowStart(), rowEnd = printInfo.rowEnd();
                        var column = columnStart === -1 ? 0 : columnStart;
                        var row = rowStart === -1 ? 0 : rowStart;
                        var columnCount = columnEnd === -1 ? sheet.getColumnCount() : columnEnd - column + 1;
                        var rowCount = rowEnd === -1 ? sheet.getRowCount() : rowEnd - row + 1;
                        var pageRange = Core_1._createRange(row, column, rowCount, columnCount);
                        var pageRect = self._render._getPaintingRects(r, c, [pageRange], intersectRect)[0];
                        var startX = void 0, startY = void 0, width = void 0, height = void 0;
                        ctx.save();
                        ctx.rect(intersectRect.x, intersectRect.y, getWidth(intersectRect), getHeight(intersectRect));
                        ctx.clip();
                        ctx.beginPath();
                        if (pageRect) {
                            startX = Math_max(pageRect.x, rowHeaderWidth);
                            startY = Math_max(pageRect.y, colHeaderHeight);
                            width = getWidth(pageRect) - startX + pageRect.x;
                            height = getHeight(pageRect) - startY + pageRect.y;
                            ctx.save();
                            ctx.rect(startX - 1, startY - 1, width + 1, height + 1);
                            ctx.clip();
                            paintPrintPreviewLine(ctx, columns, rows, columnLayoutCache, rowLayoutCache, colHeaderHeight, rowHeaderWidth, sheetLayout_height, sheetLayout_width);
                            paintPreviewPageLayout(ctx, columnStart, rowStart, columnEnd, rowEnd, startX, startY, rowHeaderWidth, colHeaderHeight, height, width);
                            ctx.stroke();
                            ctx.restore();
                        }
                        ctx.restore();
                        paintPreviewPageBreakLines(ctx, sheet, rowLayoutCache, columnLayoutCache, viewportRect);
                    }
                }
            }
        }
        delete workbook._isPrintWorkbook;
    },
    onLayoutChanged: function (e) {
        var self = this;
        var changeType = e.changeType;
        var workbook = this.parent;
        if (workbook) {
            var printLine = workbook._getPrintLine();
            if (changeType === 'addRows' || changeType === 'deleteRows' || changeType === 'addColumns' || changeType === 'deleteColumns' || changeType === 'setColumnCount' || changeType === 'setRowCount') {
                printLine.layoutChanged(self);
            }
        }
    },
    dispose: function (argus) {
        if (argus.clearCache !== false) {
            var self_1 = this;
            if (self_1._printInfo) {
                self_1._printInfo.dispose();
                self_1._printInfo = keyword_null;
            }
        }
    }
});


function getPageInfo(pageInfoTemp, printInfo) {
   
    var pageOrder = printInfo.pageOrder();
    var rows = pageInfoTemp.rows, columns = pageInfoTemp.columns;
    var isDownThenOver = pageOrder === 1  || pageOrder === 0  && rows.length >= columns.length;
    var pageInfo = {};
    var startRow = printInfo.rowStart(), startColumn = printInfo.columnStart();
    var startRowTemp = startRow = startRow === -1 ? 0 : startRow;
    var startColumnTemp = startColumn = startColumn === -1 ? 0 : startColumn;
    var pageItems = [];
    if (isDownThenOver) {
        for (var i = 0; i < columns.length; i++) {
            for (var j = 0; j < rows.length; j++) {
                var pageItem = {};
                pageItem.row = startRow;
                pageItem.column = startColumn;
                pageItem.rowCount = rows[j] - startRow + 1;
                pageItem.columnCount = columns[i] - startColumn + 1;
                startRow = rows[j] + 1;
                pageItems.push(pageItem);
            }
            startRow = startRowTemp;
            startColumn = columns[i] + 1;
        }
    }
    else {
        for (var i = 0; i < rows.length; i++) {
            for (var j = 0; j < columns.length; j++) {
                var pageItem = {};
                pageItem.row = startRow;
                pageItem.column = startColumn;
                pageItem.rowCount = rows[i] - startRow + 1;
                pageItem.columnCount = columns[j] - startColumn + 1;
                startColumn = columns[j] + 1;
                pageItems.push(pageItem);
            }
            startColumn = startColumnTemp;
            startRow = rows[i] + 1;
        }
    }
    pageInfo.pages = pageItems;
    return pageInfo;
}

function _getWorksheetCount(workbook) {
    return workbook.getSheetCount() + workbook.getSheetTabCount();
}
function _getWorksheet(workbook, index) {
    var sheet = workbook._getSheetOrSheetTab(index);
    return sheet._sheet || sheet;
}
function _getActiveWorksheetIndex(workbook) {
    var sheet = workbook._getActiveSheetOrSheetTabIndex();
    return sheet._sheet || sheet;
}
function _getActiveWorksheet(workbook) {
    var sheet = workbook._getActiveSheetOrSheetTab();
    return sheet._sheet || sheet;
}
function _getWorksheetFromName(workbook, name) {
    var sheet = workbook._getSheetOrSheetTabFromName(name);
    return sheet._sheet || sheet;
}



Core_1.Workbook.prototype.print = function (sheetIndex) {
    var self = this;
   
    if (!isUndefined(sheetIndex) && sheetIndex !== keyword_null && !(isInteger(sheetIndex) && sheetIndex >= 0 && _getWorksheetCount(self) > sheetIndex)) {
        throw new Error(getSR().Exp_InvalidSheetIndex);
    }
    if (!self._printer) {
        self._printer = new _SpreadPrinter();
    }
    var printer = self._printer;
    printer.print(self, sheetIndex);
};


Core_1.Workbook.prototype.pageInfo = function (sheetIndex) {
    var self = this;
    if (!isUndefined(sheetIndex) && sheetIndex !== keyword_null && !(isInteger(sheetIndex) && sheetIndex >= 0 && _getWorksheetCount(self) > sheetIndex)) {
        throw new Error(getSR().Exp_InvalidSheetIndex);
    }
    var printerLine = self._getPrintLine(), newWorkbook = printerLine._attachContext(self), printInfo;
    if (isUndefined(sheetIndex) || sheetIndex === keyword_null) {
        var result = [];
        for (var index = 0; index < _getWorksheetCount(self); index++) {
            var item = printerLine.pageInfo(self, newWorkbook, index, false);
            printInfo = _getWorksheet(self, index).printInfo();
            item = getPageInfo(item, printInfo);
            result.push(item);
        }
        return result;
    }
    printInfo = _getWorksheet(self, sheetIndex).printInfo();
    var pageInfoItem = printerLine.pageInfo(self, newWorkbook, sheetIndex, false);
    pageInfoItem = getPageInfo(pageInfoItem, printInfo);
    return pageInfoItem;
};
Core_1.Workbook.prototype._getPrintLine = function () {
    var self = this;
    if (!self._printerLine) {
       
        self._printerLine = new SpreadPrintLine();
    }
    return self._printerLine;
};
Core_1.Workbook._registerFeature('print', {
    dispose: function () {
        var self = this, printer = self._printer, printerLine = self._printerLine;
        if (printer) {
            printer.dispose();
            self._printer = keyword_null;
        }
        if (printerLine) {
            printerLine.dispose();
            self._printerLine = keyword_null;
        }
    },
});




var PrintVisibilityType;
(function (PrintVisibilityType) {
    
    PrintVisibilityType[PrintVisibilityType["inherit"] = 0] = "inherit";
    
    PrintVisibilityType[PrintVisibilityType["hide"] = 1] = "hide";
    
    PrintVisibilityType[PrintVisibilityType["show"] = 2] = "show";
    
    PrintVisibilityType[PrintVisibilityType["showOnce"] = 3] = "showOnce";
})(PrintVisibilityType = exports.PrintVisibilityType || (exports.PrintVisibilityType = {}));




var PrintCentering;
(function (PrintCentering) {
    
    PrintCentering[PrintCentering["none"] = 0] = "none";
    
    PrintCentering[PrintCentering["horizontal"] = 1] = "horizontal";
    
    PrintCentering[PrintCentering["vertical"] = 2] = "vertical";
    
    PrintCentering[PrintCentering["both"] = 3] = "both";
})(PrintCentering = exports.PrintCentering || (exports.PrintCentering = {}));




var PrintPageOrientation;
(function (PrintPageOrientation) {
    
    PrintPageOrientation[PrintPageOrientation["portrait"] = 1] = "portrait";
    
    PrintPageOrientation[PrintPageOrientation["landscape"] = 2] = "landscape";
})(PrintPageOrientation = exports.PrintPageOrientation || (exports.PrintPageOrientation = {}));




var PrintPageOrder;
(function (PrintPageOrder) {
    
    PrintPageOrder[PrintPageOrder["auto"] = 0] = "auto";
    
    PrintPageOrder[PrintPageOrder["downThenOver"] = 1] = "downThenOver";
    
    PrintPageOrder[PrintPageOrder["overThenDown"] = 2] = "overThenDown";
})(PrintPageOrder = exports.PrintPageOrder || (exports.PrintPageOrder = {}));




var PaperKind;
(function (PaperKind) {
    
    PaperKind[PaperKind["a2"] = 66] = "a2";
    
    PaperKind[PaperKind["a3"] = 8] = "a3";
    
    PaperKind[PaperKind["a3Extra"] = 63] = "a3Extra";
    
    PaperKind[PaperKind["a3ExtraTransverse"] = 68] = "a3ExtraTransverse";
    
    PaperKind[PaperKind["a3Rotated"] = 76] = "a3Rotated";
    
    PaperKind[PaperKind["a3Transverse"] = 67] = "a3Transverse";
    
    PaperKind[PaperKind["a4"] = 9] = "a4";
    
    PaperKind[PaperKind["a4Extra"] = 53] = "a4Extra";
    
    PaperKind[PaperKind["a4Plus"] = 60] = "a4Plus";
    
    PaperKind[PaperKind["a4Rotated"] = 77] = "a4Rotated";
    
    PaperKind[PaperKind["a4Small"] = 10] = "a4Small";
    
    PaperKind[PaperKind["a4Transverse"] = 55] = "a4Transverse";
    
    PaperKind[PaperKind["a5"] = 11] = "a5";
    
    PaperKind[PaperKind["a5Extra"] = 64] = "a5Extra";
    
    PaperKind[PaperKind["a5Rotated"] = 78] = "a5Rotated";
    
    PaperKind[PaperKind["a5Transverse"] = 61] = "a5Transverse";
    
    PaperKind[PaperKind["a6"] = 70] = "a6";
    
    PaperKind[PaperKind["a6Rotated"] = 83] = "a6Rotated";
    
    PaperKind[PaperKind["aPlus"] = 57] = "aPlus";
    
    PaperKind[PaperKind["b4"] = 12] = "b4";
    
    PaperKind[PaperKind["b4Envelope"] = 33] = "b4Envelope";
    
    PaperKind[PaperKind["b4JisRotated"] = 79] = "b4JisRotated";
    
    PaperKind[PaperKind["b5"] = 13] = "b5";
    
    PaperKind[PaperKind["b5Envelope"] = 34] = "b5Envelope";
    
    PaperKind[PaperKind["b5Extra"] = 65] = "b5Extra";
    
    PaperKind[PaperKind["b5JisRotated"] = 80] = "b5JisRotated";
    
    PaperKind[PaperKind["b5Transverse"] = 62] = "b5Transverse";
    
    PaperKind[PaperKind["b6Envelope"] = 35] = "b6Envelope";
    
    PaperKind[PaperKind["b6Jis"] = 88] = "b6Jis";
    
    PaperKind[PaperKind["b6JisRotated"] = 89] = "b6JisRotated";
    
    PaperKind[PaperKind["bPlus"] = 58] = "bPlus";
    
    PaperKind[PaperKind["c3Envelope"] = 29] = "c3Envelope";
    
    PaperKind[PaperKind["c4Envelope"] = 30] = "c4Envelope";
    
    PaperKind[PaperKind["c5Envelope"] = 28] = "c5Envelope";
    
    PaperKind[PaperKind["c65Envelope"] = 32] = "c65Envelope";
    
    PaperKind[PaperKind["c6Envelope"] = 31] = "c6Envelope";
    
    PaperKind[PaperKind["cSheet"] = 24] = "cSheet";
    
    PaperKind[PaperKind["custom"] = 0] = "custom";
    
    PaperKind[PaperKind["dlEnvelope"] = 27] = "dlEnvelope";
    
    PaperKind[PaperKind["dSheet"] = 25] = "dSheet";
    
    PaperKind[PaperKind["eSheet"] = 26] = "eSheet";
    
    PaperKind[PaperKind["executive"] = 7] = "executive";
    
    PaperKind[PaperKind["folio"] = 14] = "folio";
    
    PaperKind[PaperKind["germanLegalFanfold"] = 41] = "germanLegalFanfold";
    
    PaperKind[PaperKind["germanStandardFanfold"] = 40] = "germanStandardFanfold";
    
    PaperKind[PaperKind["inviteEnvelope"] = 47] = "inviteEnvelope";
    
    PaperKind[PaperKind["isoB4"] = 42] = "isoB4";
    
    PaperKind[PaperKind["italyEnvelope"] = 36] = "italyEnvelope";
    
    PaperKind[PaperKind["japaneseDoublePostcard"] = 69] = "japaneseDoublePostcard";
    
    PaperKind[PaperKind["japaneseDoublePostcardRotated"] = 82] = "japaneseDoublePostcardRotated";
    
    PaperKind[PaperKind["japaneseEnvelopeChouNumber3"] = 73] = "japaneseEnvelopeChouNumber3";
    
    PaperKind[PaperKind["japaneseEnvelopeChouNumber3Rotated"] = 86] = "japaneseEnvelopeChouNumber3Rotated";
    
    PaperKind[PaperKind["japaneseEnvelopeChouNumber4"] = 74] = "japaneseEnvelopeChouNumber4";
    
    PaperKind[PaperKind["japaneseEnvelopeChouNumber4Rotated"] = 87] = "japaneseEnvelopeChouNumber4Rotated";
    
    PaperKind[PaperKind["japaneseEnvelopeKakuNumber2"] = 71] = "japaneseEnvelopeKakuNumber2";
    
    PaperKind[PaperKind["japaneseEnvelopeKakuNumber2Rotated"] = 84] = "japaneseEnvelopeKakuNumber2Rotated";
    
    PaperKind[PaperKind["japaneseEnvelopeKakuNumber3"] = 72] = "japaneseEnvelopeKakuNumber3";
    
    PaperKind[PaperKind["japaneseEnvelopeKakuNumber3Rotated"] = 85] = "japaneseEnvelopeKakuNumber3Rotated";
    
    PaperKind[PaperKind["japaneseEnvelopeYouNumber4"] = 91] = "japaneseEnvelopeYouNumber4";
    
    PaperKind[PaperKind["japaneseEnvelopeYouNumber4Rotated"] = 92] = "japaneseEnvelopeYouNumber4Rotated";
    
    PaperKind[PaperKind["japanesePostcard"] = 43] = "japanesePostcard";
    
    PaperKind[PaperKind["japanesePostcardRotated"] = 81] = "japanesePostcardRotated";
    
    PaperKind[PaperKind["ledger"] = 4] = "ledger";
    
    PaperKind[PaperKind["legal"] = 5] = "legal";
    
    PaperKind[PaperKind["legalExtra"] = 51] = "legalExtra";
    
    PaperKind[PaperKind["letter"] = 1] = "letter";
    
    PaperKind[PaperKind["letterExtra"] = 50] = "letterExtra";
    
    PaperKind[PaperKind["letterExtraTransverse"] = 56] = "letterExtraTransverse";
    
    PaperKind[PaperKind["letterPlus"] = 59] = "letterPlus";
    
    PaperKind[PaperKind["letterRotated"] = 75] = "letterRotated";
    
    PaperKind[PaperKind["letterSmall"] = 2] = "letterSmall";
    
    PaperKind[PaperKind["letterTransverse"] = 54] = "letterTransverse";
    
    PaperKind[PaperKind["monarchEnvelope"] = 37] = "monarchEnvelope";
    
    PaperKind[PaperKind["note"] = 18] = "note";
    
    PaperKind[PaperKind["number10Envelope"] = 20] = "number10Envelope";
    
    PaperKind[PaperKind["number11Envelope"] = 21] = "number11Envelope";
    
    PaperKind[PaperKind["number12Envelope"] = 22] = "number12Envelope";
    
    PaperKind[PaperKind["number14Envelope"] = 23] = "number14Envelope";
    
    PaperKind[PaperKind["number9Envelope"] = 19] = "number9Envelope";
    
    PaperKind[PaperKind["personalEnvelope"] = 38] = "personalEnvelope";
    
    PaperKind[PaperKind["prc16K"] = 93] = "prc16K";
    
    PaperKind[PaperKind["prc16KRotated"] = 106] = "prc16KRotated";
    
    PaperKind[PaperKind["prc32K"] = 94] = "prc32K";
    
    PaperKind[PaperKind["prc32KBig"] = 95] = "prc32KBig";
    
    PaperKind[PaperKind["prc32KBigRotated"] = 108] = "prc32KBigRotated";
    
    PaperKind[PaperKind["prc32KRotated"] = 107] = "prc32KRotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber1"] = 96] = "prcEnvelopeNumber1";
    
    PaperKind[PaperKind["prcEnvelopeNumber10"] = 105] = "prcEnvelopeNumber10";
    
    PaperKind[PaperKind["prcEnvelopeNumber10Rotated"] = 118] = "prcEnvelopeNumber10Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber1Rotated"] = 109] = "prcEnvelopeNumber1Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber2"] = 97] = "prcEnvelopeNumber2";
    
    PaperKind[PaperKind["prcEnvelopeNumber2Rotated"] = 110] = "prcEnvelopeNumber2Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber3"] = 98] = "prcEnvelopeNumber3";
    
    PaperKind[PaperKind["prcEnvelopeNumber3Rotated"] = 111] = "prcEnvelopeNumber3Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber4"] = 99] = "prcEnvelopeNumber4";
    
    PaperKind[PaperKind["prcEnvelopeNumber4Rotated"] = 112] = "prcEnvelopeNumber4Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber5"] = 100] = "prcEnvelopeNumber5";
    
    PaperKind[PaperKind["prcEnvelopeNumber5Rotated"] = 113] = "prcEnvelopeNumber5Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber6"] = 101] = "prcEnvelopeNumber6";
    
    PaperKind[PaperKind["prcEnvelopeNumber6Rotated"] = 114] = "prcEnvelopeNumber6Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber7"] = 102] = "prcEnvelopeNumber7";
    
    PaperKind[PaperKind["prcEnvelopeNumber7Rotated"] = 115] = "prcEnvelopeNumber7Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber8"] = 103] = "prcEnvelopeNumber8";
    
    PaperKind[PaperKind["prcEnvelopeNumber8Rotated"] = 116] = "prcEnvelopeNumber8Rotated";
    
    PaperKind[PaperKind["prcEnvelopeNumber9"] = 104] = "prcEnvelopeNumber9";
    
    PaperKind[PaperKind["prcEnvelopeNumber9Rotated"] = 117] = "prcEnvelopeNumber9Rotated";
    
    PaperKind[PaperKind["quarto"] = 15] = "quarto";
    
    PaperKind[PaperKind["standard10x11"] = 45] = "standard10x11";
    
    PaperKind[PaperKind["standard10x14"] = 16] = "standard10x14";
    
    PaperKind[PaperKind["standard11x17"] = 17] = "standard11x17";
    
    PaperKind[PaperKind["standard12x11"] = 90] = "standard12x11";
    
    PaperKind[PaperKind["standard15x11"] = 46] = "standard15x11";
    
    PaperKind[PaperKind["standard9x11"] = 44] = "standard9x11";
    
    PaperKind[PaperKind["statement"] = 6] = "statement";
    
    PaperKind[PaperKind["tabloid"] = 3] = "tabloid";
    
    PaperKind[PaperKind["tabloidExtra"] = 52] = "tabloidExtra";
    
    PaperKind[PaperKind["usStandardFanfold"] = 39] = "usStandardFanfold";
})(PaperKind = exports.PaperKind || (exports.PaperKind = {}));



var PaperSize =  (function () {
    function PaperSize(widthOrKind, height) {
        var self = this;
        var argumentsLength = arguments.length;
        if (argumentsLength === 1) {
            self.kind(widthOrKind);
        }
        else if (argumentsLength === 2) {
            self._width = widthOrKind;
            self._height = height;
            self._kind = PaperKind.custom ;
        }
        else {
            self.kind(PaperKind.letter );
        }
    }
   
    
    PaperSize.prototype.height = function (value) {
        var self = this;
        if (arguments.length === 0) {
            return self._height;
        }
        if (self._height !== value) {
            self._kind = 0 ;
        }
        self._height = value;
        return self;
    };
   
    
    PaperSize.prototype.width = function (value) {
        var self = this;
        if (arguments.length === 0) {
            return self._width;
        }
        if (self._width !== value) {
            self._kind = 0 ;
        }
        self._width = value;
        return self;
    };
   
    
    PaperSize.prototype.kind = function (value) {
        var self = this;
        if (arguments.length === 0) {
            return self._kind;
        }
        self._kind = value;
        var size = self.getPageSize(value);
        self._width = size.width;
        self._height = size.height;
        return self;
    };
   
    
    PaperSize.prototype.getPageSize = function (kind) {
        function _toHundredthsOfInch(num, isInch) {
            return isInch ? num * 100 : num / 25.4 * 100;
        }
        function _fromInch(width, height) {
            return { width: _toHundredthsOfInch(width, true), height: _toHundredthsOfInch(height, true) };
        }
        function _fromMM(width, height) {
            return { width: _toHundredthsOfInch(width, false), height: _toHundredthsOfInch(height, false) };
        }
        switch (kind) {
            case PaperKind.custom:
                return { width: 0, height: 0 };
            case PaperKind.letter:
                return _fromInch(8.5, 11);
            case PaperKind.legal:
                return _fromInch(8.5, 14);
            case PaperKind.a4:
                return _fromMM(210, 297);
            case PaperKind.cSheet:
                return _fromInch(17, 22);
            case PaperKind.dSheet:
                return _fromInch(22, 34);
            case PaperKind.eSheet:
                return _fromInch(34, 44);
            case PaperKind.letterSmall:
                return _fromInch(8.5, 11);
            case PaperKind.tabloid:
                return _fromInch(11, 17);
            case PaperKind.ledger:
                return _fromInch(17, 11);
            case PaperKind.statement:
                return _fromInch(5.5, 8.5);
            case PaperKind.executive:
                return _fromInch(7.25, 10.5);
            case PaperKind.a3:
                return _fromMM(297, 420);
            case PaperKind.a4Small:
                return _fromMM(210, 297);
            case PaperKind.a5:
                return _fromMM(148, 210);
            case PaperKind.b4:
                return _fromMM(250, 353);
            case PaperKind.b5:
                return _fromMM(176, 250);
            case PaperKind.folio:
                return _fromInch(8.5, 13);
            case PaperKind.quarto:
                return _fromMM(215, 275);
            case PaperKind.standard10x14:
                return _fromInch(10, 14);
            case PaperKind.standard11x17:
                return _fromInch(11, 17);
            case PaperKind.note:
                return _fromInch(8.5, 11);
            case PaperKind.number9Envelope:
                return _fromInch(3.875, 8.875);
            case PaperKind.number10Envelope:
                return _fromInch(4.125, 9.5);
            case PaperKind.number11Envelope:
                return _fromInch(4.5, 10.375);
            case PaperKind.number12Envelope:
                return _fromInch(4.75, 11);
            case PaperKind.number14Envelope:
                return _fromInch(5, 11.5);
            case PaperKind.dlEnvelope:
                return _fromMM(110, 220);
            case PaperKind.c5Envelope:
                return _fromMM(162, 229);
            case PaperKind.c3Envelope:
                return _fromMM(324, 458);
            case PaperKind.c4Envelope:
                return _fromMM(229, 324);
            case PaperKind.c6Envelope:
                return _fromMM(114, 162);
            case PaperKind.c65Envelope:
                return _fromMM(114, 229);
            case PaperKind.b4Envelope:
                return _fromMM(250, 353);
            case PaperKind.b5Envelope:
                return _fromMM(176, 250);
            case PaperKind.b6Envelope:
                return _fromMM(176, 125);
            case PaperKind.italyEnvelope:
                return _fromMM(110, 230);
            case PaperKind.monarchEnvelope:
                return _fromInch(3.875, 7.5);
            case PaperKind.personalEnvelope:
                return _fromInch(3.625, 6.5);
            case PaperKind.usStandardFanfold:
                return _fromInch(14.875, 11);
            case PaperKind.germanStandardFanfold:
                return _fromInch(8.5, 12);
            case PaperKind.germanLegalFanfold:
                return _fromInch(8.5, 13);
            case PaperKind.isoB4:
                return _fromMM(250, 353);
            case PaperKind.japanesePostcard:
                return _fromMM(100, 148);
            case PaperKind.standard9x11:
                return _fromInch(9, 11);
            case PaperKind.standard10x11:
                return _fromInch(10, 11);
            case PaperKind.standard15x11:
                return _fromInch(15, 11);
            case PaperKind.inviteEnvelope:
                return _fromMM(220, 220);
            case PaperKind.letterExtra:
                return _fromInch(9.275, 12);
            case PaperKind.legalExtra:
                return _fromInch(9.275, 15);
            case PaperKind.tabloidExtra:
                return _fromInch(11.69, 18);
            case PaperKind.a4Extra:
                return _fromMM(236, 322);
            case PaperKind.letterTransverse:
                return _fromInch(8.275, 11);
            case PaperKind.a4Transverse:
                return _fromMM(210, 297);
            case PaperKind.letterExtraTransverse:
                return _fromInch(9.275, 12);
            case PaperKind.aPlus:
                return _fromMM(227, 356);
            case PaperKind.bPlus:
                return _fromMM(305, 487);
            case PaperKind.letterPlus:
                return _fromInch(8.5, 12.69);
            case PaperKind.a4Plus:
                return _fromMM(210, 330);
            case PaperKind.a5Transverse:
                return _fromMM(148, 210);
            case PaperKind.b5Transverse:
                return _fromMM(182, 257);
            case PaperKind.a3Extra:
                return _fromMM(322, 445);
            case PaperKind.a5Extra:
                return _fromMM(174, 235);
            case PaperKind.b5Extra:
                return _fromMM(201, 276);
            case PaperKind.a2:
                return _fromMM(420, 594);
            case PaperKind.a3Transverse:
                return _fromMM(297, 420);
            case PaperKind.a3ExtraTransverse:
                return _fromMM(322, 445);
            case PaperKind.japaneseDoublePostcard:
                return _fromMM(200, 148);
            case PaperKind.a6:
                return _fromMM(105, 148);
            case PaperKind.japaneseEnvelopeKakuNumber2:
                return _fromMM(240, 332);
            case PaperKind.japaneseEnvelopeKakuNumber3:
                return _fromMM(216, 277);
            case PaperKind.japaneseEnvelopeChouNumber3:
                return _fromMM(120, 235);
            case PaperKind.japaneseEnvelopeChouNumber4:
                return _fromMM(90, 205);
            case PaperKind.letterRotated:
                return _fromInch(11, 8.5);
            case PaperKind.a3Rotated:
                return _fromMM(420, 297);
            case PaperKind.a4Rotated:
                return _fromMM(297, 210);
            case PaperKind.a5Rotated:
                return _fromMM(210, 148);
            case PaperKind.b4JisRotated:
                return _fromMM(364, 257);
            case PaperKind.b5JisRotated:
                return _fromMM(257, 182);
            case PaperKind.japanesePostcardRotated:
                return _fromMM(148, 100);
            case PaperKind.japaneseDoublePostcardRotated:
                return _fromMM(148, 200);
            case PaperKind.a6Rotated:
                return _fromMM(148, 105);
            case PaperKind.japaneseEnvelopeKakuNumber2Rotated:
                return _fromMM(332, 240);
            case PaperKind.japaneseEnvelopeKakuNumber3Rotated:
                return _fromMM(277, 216);
            case PaperKind.japaneseEnvelopeChouNumber3Rotated:
                return _fromMM(235, 120);
            case PaperKind.japaneseEnvelopeChouNumber4Rotated:
                return _fromMM(205, 90);
            case PaperKind.b6Jis:
                return _fromMM(128, 182);
            case PaperKind.b6JisRotated:
                return _fromMM(182, 128);
            case PaperKind.standard12x11:
                return _fromInch(12, 11);
            case PaperKind.japaneseEnvelopeYouNumber4:
                return _fromMM(235, 105);
            case PaperKind.japaneseEnvelopeYouNumber4Rotated:
                return _fromMM(105, 235);
            case PaperKind.prc16K:
                return _fromMM(146, 215);
            case PaperKind.prc32K:
                return _fromMM(97, 151);
            case PaperKind.prc32KBig:
                return _fromMM(97, 151);
            case PaperKind.prcEnvelopeNumber1:
                return _fromMM(102, 165);
            case PaperKind.prcEnvelopeNumber2:
                return _fromMM(102, 176);
            case PaperKind.prcEnvelopeNumber3:
                return _fromMM(125, 176);
            case PaperKind.prcEnvelopeNumber4:
                return _fromMM(110, 208);
            case PaperKind.prcEnvelopeNumber5:
                return _fromMM(110, 220);
            case PaperKind.prcEnvelopeNumber6:
                return _fromMM(120, 230);
            case PaperKind.prcEnvelopeNumber7:
                return _fromMM(160, 230);
            case PaperKind.prcEnvelopeNumber8:
                return _fromMM(120, 309);
            case PaperKind.prcEnvelopeNumber9:
                return _fromMM(229, 324);
            case PaperKind.prcEnvelopeNumber10:
                return _fromMM(324, 458);
            case PaperKind.prc16KRotated:
                return _fromMM(146, 215);
            case PaperKind.prc32KRotated:
                return _fromMM(97, 151);
            case PaperKind.prc32KBigRotated:
                return _fromMM(97, 151);
            case PaperKind.prcEnvelopeNumber1Rotated:
                return _fromMM(165, 102);
            case PaperKind.prcEnvelopeNumber2Rotated:
                return _fromMM(176, 102);
            case PaperKind.prcEnvelopeNumber3Rotated:
                return _fromMM(176, 125);
            case PaperKind.prcEnvelopeNumber4Rotated:
                return _fromMM(208, 110);
            case PaperKind.prcEnvelopeNumber5Rotated:
                return _fromMM(220, 110);
            case PaperKind.prcEnvelopeNumber6Rotated:
                return _fromMM(230, 120);
            case PaperKind.prcEnvelopeNumber7Rotated:
                return _fromMM(230, 160);
            case PaperKind.prcEnvelopeNumber8Rotated:
                return _fromMM(309, 120);
            case PaperKind.prcEnvelopeNumber9Rotated:
                return _fromMM(324, 229);
            case PaperKind.prcEnvelopeNumber10Rotated:
                return _fromMM(458, 324);
            default:
                return { width: 0, height: 0 };
        }
    };
    PaperSize.prototype.toJSON = function () {
        return {
            width: this._width,
            height: this._height,
            kind: this._kind
        };
    };
    PaperSize.prototype.fromJSON = function (setting) {
        var self = this, hasWidth = false, hasHeight = false, hasKind = false;
        if (!isUndefined(setting.width)) {
            self._width = setting.width;
            hasWidth = true;
        }
        if (!isUndefined(setting.height)) {
            self._height = setting.height;
            hasHeight = true;
        }
        if (!isUndefined(setting.kind)) {
            self._kind = setting.kind;
            hasKind = true;
        }
        if ((!hasWidth || !hasHeight) && hasKind) {
            var size = self.getPageSize(self._kind);
            self._width = size.width;
            self._height = size.height;
        }
    };
    return PaperSize;
}());
exports.PaperSize = PaperSize;










var DEFAULT_MARGIN = '{"top":75,"bottom":75,"left":70,"right":70,"header":30,"footer":30}';
var PrintInfoPropertyDict = {
    bestFitRows: false,
    bestFitColumns: false,
    columnStart: -1,
    columnEnd: -1,
    rowStart: -1,
    rowEnd: -1,
    repeatColumnStart: -1,
    repeatColumnEnd: -1,
    repeatRowStart: -1,
    repeatRowEnd: -1,
    showBorder: true,
    showGridLine: false,
    showColumnHeader: 0 ,
    showRowHeader: 0 ,
    useMax: true,
    centering: 0 ,
    firstPageNumber: 1,
    headerLeft: str_empty,
    headerCenter: str_empty,
    headerRight: str_empty,
    footerLeft: str_empty,
    footerCenter: str_empty,
    footerRight: str_empty,
    headerLeftImage: str_empty,
    headerCenterImage: str_empty,
    headerRightImage: str_empty,
    footerLeftImage: str_empty,
    footerCenterImage: str_empty,
    footerRightImage: str_empty,
    margin: JSON_parse(DEFAULT_MARGIN),
    orientation: 1 ,
    pageRange: str_empty,
    pageOrder: 0 ,
    blackAndWhite: false,
    zoomFactor: 1,
    fitPagesTall: -1,
    fitPagesWide: -1,
    paperSize: {},
    qualityFactor: 2,
    watermark: []
};




















































































var PrintInfo =  (function () {
    function PrintInfo(sheet) {
        var self = this;
        self._sheet = sheet;
        $_each(PrintInfoPropertyDict, function (p, v) {
            if (p === str_margin) {
                self['_' + p] = JSON_parse(DEFAULT_MARGIN);
            }
            else if (p === str_paperSize) {
                self['_' + p] = new PaperSize();
            }
            else {
                self['_' + p] = v;
            }
        });
    }
    PrintInfo.prototype.dispose = function () {
        this._sheet = keyword_null;
    };
    PrintInfo.prototype.toJSON = function () {
        function isDefaultValue(propertyName, value, printInfo) {
            var isDefault = false, defaultValue = PrintInfoPropertyDict[propertyName];
            if (propertyName === str_margin) {
                isDefault = JSON_stringify(defaultValue) === JSON_stringify(value);
            }
            else if (propertyName === str_paperSize) {
                isDefault = value.width === 850 && value.height === 1100 && value.kind === 0 ;
            }
            else if (propertyName === str_firstPageNumber) {
                isDefault = value === 1 && !printInfo._isFirstPageNumberSet;
            }
            else {
                isDefault = defaultValue === value;
            }
            return isDefault;
        }
        var self = this;
        var dataDic = {}, currentValue;
        $_each(PrintInfoPropertyDict, function (p) {
            currentValue = self['_' + p];
            if (!isDefaultValue(p, currentValue, self)) {
                if (p === str_paperSize) {
                    dataDic[p] = currentValue.toJSON();
                }
                else {
                    dataDic[p] = currentValue;
                }
            }
        });
        return dataDic;
    };
    PrintInfo.prototype.fromJSON = function (setting) {
        var self = this;
        $_each(PrintInfoPropertyDict, function (p) {
            var jsonValue = setting[p];
            if (!isUndefined(jsonValue)) {
                if (p === str_paperSize) {
                    self['_' + p].fromJSON(jsonValue);
                }
                else if (p === str_margin) {
                   
                   
                   
                    var margin_1 = {};
                    $_each(PrintInfoPropertyDict[str_margin], function (_p) {
                        var subJsonValue = jsonValue[_p];
                        if (!isUndefined(subJsonValue)) {
                            margin_1[_p] = subJsonValue;
                        }
                        else {
                            margin_1[_p] = PrintInfoPropertyDict[str_margin][_p];
                        }
                    });
                    self['_' + p] = margin_1;
                }
                else {
                    if (p === str_firstPageNumber) {
                        self._isFirstPageNumberSet = true;
                    }
                    self['_' + p] = jsonValue;
                }
            }
        });
    };
    return PrintInfo;
}());
exports.PrintInfo = PrintInfo;
var PrintInfoPrototype = {};
$_each(PrintInfoPropertyDict, function (p) {
    PrintInfoPrototype[p] = function (value) {
        if (arguments.length === 0) {
            return this['_' + p];
        }
        if (p === 'zoomFactor') {
            if (value < 0.1) {
                value = 0.1;
            }
            else if (value > 4) {
                value = 4;
            }
        }
        else if (p === 'qualityFactor') {
            var validValue = parseIntFn(value, 10);
            if (validValue < 1) {
                validValue = 1;
            }
            else if (validValue > 8) {
                validValue = 8;
            }
            value = validValue;
        }
        else if (p === str_firstPageNumber) {
            this._isFirstPageNumberSet = true;
        }
        else if ((p === 'fitPagesTall' || p === 'fitPagesWide') && value <= 0) {
            value = -1;
        }
        var sheet = this._sheet;
        this['_' + p] = value;
        if (sheet && sheet.isPrintLineVisible() === true) {
            sheet.repaint();
        }
        return this;
    };
});
$_extend(PrintInfo.prototype, PrintInfoPrototype);


function isUndefined(v) {
    return typeof v === 'undefined';
}
function createElement(doc, tagName) {
    return doc.createElement(tagName);
}
function initPrintingSize(sheet, printInfo, outParam) {
    var paperSize = getPaperSize(sheet, printInfo.paperSize(), printInfo.orientation(), !printInfo.showBorder()), paperWidth = paperSize.width, paperHeight = paperSize.height;
    var margin = getMargin(printInfo.margin());
    var leftMargin = margin.left;
    var topMargin = margin.top;
    var rightMargin = margin.right;
    var bottomMargin = margin.bottom;
    outParam.paperSize = { width: paperWidth, height: paperHeight };
    outParam.pageImageableArea = new Core_1.Rect(leftMargin, topMargin, paperWidth - leftMargin - rightMargin, paperHeight - topMargin - bottomMargin);
}
function getPaperSize(sheet, originalPaperSize, orientation, needTopLeftLine) {
    var factor = 0.96;
    var size = {};
    var originalPaperWidth = originalPaperSize.width() * factor, originalPaperHeight = originalPaperSize.height() * factor;
    if (orientation === PrintPageOrientation.landscape ) {
        if (originalPaperSize.kind() === PaperKind.a4) {
            originalPaperWidth = originalPaperWidth - 1;
        }
        size.width = originalPaperHeight;
        size.height = parseIntFn(originalPaperWidth + '', 10);
    }
    else {
        if (originalPaperSize.kind() === PaperKind.a4) {
            originalPaperHeight = originalPaperHeight - 1;
        }
        size.width = originalPaperWidth;
        size.height = parseIntFn(originalPaperHeight + '', 10);
    }
    if (needTopLeftLine) {
        var sheetAreaOffset = sheet.options.sheetAreaOffset;
        size.width -= sheetAreaOffset.left;
        size.height -= sheetAreaOffset.top;
    }
    return size;
}
function getMargin(originalMargin) {
    var factor = 0.96;
    var margin = {};
    margin.left = originalMargin.left * factor;
    margin.top = originalMargin.top * factor;
    margin.right = originalMargin.right * factor;
    margin.bottom = originalMargin.bottom * factor;
    margin.header = originalMargin.header * factor;
    margin.footer = originalMargin.footer * factor;
    return margin;
}
function getPageRange(pageRange) {
    if (!pageRange) {
        return [];
    }
    var pages = [];
    var ranges = pageRange.split(','), tmpRange, index, start, end, step, tmpIndex;
    var i = 0, count = ranges.length;
    for (; i < count; i++) {
        tmpRange = ranges[i].trim();
        if (!tmpRange) {
            continue;
        }
        index = tmpRange.indexOf('-');
        if (index >= 0) {
            start = parseIntFn(tmpRange.substr(0, index), 10);
            end = parseIntFn(tmpRange.substr(index + 1), 10);
            step = end >= start ? 1 : -1;
            for (tmpIndex = start; tmpIndex !== end; tmpIndex += step) {
                pages.push(tmpIndex);
            }
            pages.push(end);
        }
        else {
            pages.push(parseIntFn(tmpRange, 10));
        }
    }
    return pages;
}
function modifyPageIndexes(pageIndexes, pageCount) {
    pageIndexes.sort(function (a, b) {
        return a - b;
    });
    var removeArray = [], i = 0, count = pageIndexes.length, j;
    for (; i < count; i++) {
        pageIndexes[i] -= 1;
        if (pageIndexes[i] >= pageCount || pageIndexes[i] < 0) {
            removeArray.push(i);
        }
    }
    for (j = removeArray.length - 1; j >= 0; j--) {
        pageIndexes.splice(removeArray[j], 1);
    }
}
function getLastNonEmptyColumn(sheet) {
    var modelManager = sheet._modelManager, lastDirtyColumn = modelManager.getLastNonNullCol(3, true), lastDirtyRow = modelManager.getLastNonNullRow(3, true), tables = sheet.tables && sheet.tables.all();
    var c, columnStyle, i, length, tableRange, r, col, colCount;
    for (c = lastDirtyColumn; c >= 0; c--) {
        columnStyle = sheet._getStyleImp(-1, c);
        if (isValidatingStyleForPrinting(columnStyle)) {
            return c;
        }
        if (tables) {
            length = tables.length;
            for (i = 0; i < length; i++) {
                tableRange = tables[i].range();
                col = tableRange.col;
                colCount = tableRange.colCount;
                var lastTableColumn = col + colCount - 1;
                if (c >= col && c <= lastTableColumn) {
                    return lastTableColumn;
                }
            }
        }
        for (r = 0; r <= lastDirtyRow; r++) {
            if (isCellNonEmpty(sheet, r, c)) {
                return c;
            }
        }
    }
    return -1;
}
function getLastNonEmptyRow(sheet) {
    var modelManager = sheet._modelManager, lastDirtyColumn = modelManager.getLastNonNullCol(3, true), lastDirtyRow = modelManager.getLastNonNullRow(3, true), tables = sheet.tables && sheet.tables.all();
    var r, rowStyle, i, length, tableRange, c, row, rowCount;
    for (r = lastDirtyRow; r >= 0; r--) {
        rowStyle = sheet._getStyleImp(r, -1);
        if (isValidatingStyleForPrinting(rowStyle)) {
            return r;
        }
        if (tables) {
            length = tables.length;
            for (i = 0; i < length; i++) {
                tableRange = tables[i].range();
                row = tableRange.row;
                rowCount = tableRange.rowCount;
                var tableLastRow = row + rowCount - 1;
                if (r >= row && r <= tableLastRow) {
                    return tableLastRow;
                }
            }
        }
        for (c = 0; c <= lastDirtyColumn; c++) {
            if (isCellNonEmpty(sheet, r, c)) {
                return r;
            }
        }
    }
    return -1;
}
function isCellNonEmpty(sheet, r, c) {
    var value = sheet.getValue(r, c), sparkline, style;
    if (value !== keyword_null && !isUndefined(value)) {
        return true;
    }
    sparkline = sheet.getSparkline && sheet.getSparkline(r, c);
    if (sparkline) {
        return true;
    }
    style = sheet._getStyleImp(r, c);
    return isValidatingStyleForPrinting(style);
}
function isValidatingStyleForPrinting(style) {
    return !!(style && (style.backColor || style.backgroundImage
        || style.borderBottom || style.borderLeft || style.borderRight || style.borderTop
        || style.diagonalDown || style.diagonalUp || (style.cellButtons && style.cellButtons.length > 0)
        || (style.cellType && style.cellType.typeName !== "1" ) ));
}
function iteratePicturesAndCharts(sheet, callback) {
    var floatingObjects = [];
    var pictures = sheet.pictures && sheet.pictures.all();
    if (pictures) {
        floatingObjects = floatingObjects.concat(pictures);
    }
    var charts = sheet.charts && sheet.charts.all();
    if (charts) {
        floatingObjects = floatingObjects.concat(charts);
    }
    floatingObjects.forEach(callback);
}
function getLastFloatingObjectDirtyIndex(sheet, isRow) {
    var lastDirtyIndex = -1;
   
    iteratePicturesAndCharts(sheet, function (floatingObject) {
        if (floatingObject.isVisible() && floatingObject.canPrint()) {
            lastDirtyIndex = Math_max(lastDirtyIndex, isRow ? floatingObject.endRow() : floatingObject.endColumn());
        }
    });
    return lastDirtyIndex;
}
function _getOverflowMaxEndColumn(sheet) {
   
   
    var cachePool = sheet._cachePool, rowCount = getLastNonEmptyRow(sheet) + 1;
    var width = 0;
    for (var headerCol = 0, headerColCount = sheet.getColumnCount(2 ); headerCol < headerColCount; headerCol++) {
        width += sheet._getZoomColumnWidth(headerCol, 2 );
    }
    for (var col = 0, colCount = sheet.getColumnCount(); col < colCount; col++) {
        width += cachePool._getZoomColWidth(col);
    }
    var height = 0;
    for (var headerRow = 0, headerRowCount = sheet.getRowCount(1 ); headerRow < headerRowCount; headerRow++) {
        height += sheet._getZoomRowHeight(headerRow, 1 );
    }
    for (var row = 0; row < rowCount; row++) {
        height += cachePool._getZoomRowHeight(row);
    }
    var rect = new Core_1.Rect(0, 0, width, height);
    sheet._setBounds(rect);
    sheet.invalidateLayout();
    var maxOverflowColumn = -1;
    for (var rowIndex = 0; rowIndex < rowCount; rowIndex++) {
        var rowViewportIndex = sheet._getRowViewportIndex(rowIndex);
        for (var colViewportIndex = 0; colViewportIndex <= 2; colViewportIndex++) {
            var layoutBuilder = new Core_1._CellOverflowLayoutBuilder(sheet, rowViewportIndex, colViewportIndex);
            var overflowLayoutModel = layoutBuilder._getCellOverflowLayoutModel(rowIndex);
            for (var i = 0, length_1 = overflowLayoutModel.length; i < length_1; i++) {
                var overflowLayout = overflowLayoutModel[i];
                if (overflowLayout.endColumn > maxOverflowColumn) {
                    maxOverflowColumn = overflowLayout.endColumn;
                }
            }
            var headingOverflowlayouts = overflowLayoutModel.headingOverflowlayouts;
            if (headingOverflowlayouts && headingOverflowlayouts[0] && headingOverflowlayouts[0].endColumn > maxOverflowColumn) {
                maxOverflowColumn = headingOverflowlayouts[0].endColumn;
            }
            var trailingOverflowLayouts = overflowLayoutModel.trailingOverflowLayouts;
            if (trailingOverflowLayouts && trailingOverflowLayouts[0] && trailingOverflowLayouts[0].endColumn > maxOverflowColumn) {
                maxOverflowColumn = trailingOverflowLayouts[0].endColumn;
            }
        }
    }
    return maxOverflowColumn;
}
function _getSpanMaxIndex(spans, rowCount, colCount) {
    var maxColIndex = -1, maxRowIndex = -1;
    _eachSpan(spans, 0, 0, rowCount, colCount, function (span) {
        var maxSpanColIndex = span.col + span.colCount - 1;
        var maxSpanRowIndex = span.row + span.rowCount - 1;
        if (maxSpanColIndex > maxColIndex) {
            maxColIndex = maxSpanColIndex;
        }
        if (maxSpanRowIndex > maxRowIndex) {
            maxRowIndex = maxSpanRowIndex;
        }
    });
    return { colIndex: maxColIndex, rowIndex: maxRowIndex };
}
function _eachSpan(spans, row, col, rowCount, colCount, callback) {
    var self = spans;
    for (var i = 0, length_2 = self.length; i < length_2; i++) {
        if (row >= 0 || col >= 0) {
            while (i < length_2 && !self[i].intersect(row, col, rowCount, colCount)) {
                i++;
            }
        }
        if (i < length_2 && callback) {
            var value = callback(self[i]);
            if (value === false) {
                break;
            }
        }
    }
}
function _getLastSpanDirtyColumn(sheet) {
    var maxColumnIndex = -1;
   
    var colHeaderSpans = sheet._modelManager.getSpans(keyword_null, 1 );
    var colHeaderRowCount = sheet.getRowCount(1), colHeaderColCount = sheet.getColumnCount(1);
    maxColumnIndex = Math_max(maxColumnIndex, _getSpanMaxIndex(colHeaderSpans, colHeaderRowCount, colHeaderColCount).colIndex);
   
    var vpSpans = sheet._modelManager.getSpans(keyword_null, 3 );
    var vpRowCount = sheet.getRowCount(), vpColCount = sheet.getColumnCount();
    maxColumnIndex = Math_max(maxColumnIndex, _getSpanMaxIndex(vpSpans, vpRowCount, vpColCount).colIndex);
    return maxColumnIndex;
}
function _getLastSpanDirtyRow(sheet) {
    var maxRowIndex = -1;
   
    var rowHeaderSpans = sheet._modelManager.getSpans(keyword_null, 2 );
    var rowHeaderRowCount = sheet.getRowCount(2), rowHeaderColCount = sheet.getColumnCount(2);
    maxRowIndex = Math_max(maxRowIndex, _getSpanMaxIndex(rowHeaderSpans, rowHeaderRowCount, rowHeaderColCount).rowIndex);
   
    var vpSpans = sheet._modelManager.getSpans(keyword_null, 3 );
    var vpRowCount = sheet.getRowCount(), vpColCount = sheet.getColumnCount();
    maxRowIndex = Math_max(maxRowIndex, _getSpanMaxIndex(vpSpans, vpRowCount, vpColCount).rowIndex);
    return maxRowIndex;
}
function getLastPrintingColumn(sheet, printSettings) {
    var columnEnd, printSettings_columnEnd = printSettings.columnEnd(), sheet_columnCount = sheet.getColumnCount();
    if (printSettings_columnEnd === -1) {
        var lastColumn = void 0;
        if (printSettings.useMax()) {
            var lastDirtyColumn = getLastNonEmptyColumn(sheet);
            if (sheet.options.allowCellOverflow) {
                var maxOverflowColumn = _getOverflowMaxEndColumn(sheet);
                lastDirtyColumn = Math_max(lastDirtyColumn, maxOverflowColumn);
            }
            var lastFBDirtyColumn = getLastFloatingObjectDirtyIndex(sheet, false);
            var lastSPDirtyColum_1 = -1;
            if (sheet.shapes) {
                lastSPDirtyColum_1 = sheet.shapes._getLastColumnShapeDirtyIndex();
            }
            if (!(!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 0)) {
                var pivotTables = sheet.pivotTables._pivotTables;
                pivotTables.forEach(function (pt) {
                    if (pt._isEmpty()) {
                       
                        var ptPosition = pt.position();
                        if (lastSPDirtyColum_1 <= ptPosition.col + 3 - 1) {
                            lastSPDirtyColum_1 = ptPosition.col + 3 - 1;
                        }
                    }
                });
            }
            lastColumn = Math_max(lastDirtyColumn, lastFBDirtyColumn, lastSPDirtyColum_1);
            var lastSpanDirtyColumn = _getLastSpanDirtyColumn(sheet);
            lastColumn = Math_max(lastColumn, lastSpanDirtyColumn);
        }
        else {
            lastColumn = sheet_columnCount - 1;
        }
        columnEnd = lastColumn;
    }
    else {
        columnEnd = printSettings_columnEnd;
    }
    columnEnd = Math_min(columnEnd, sheet_columnCount - 1);
    return columnEnd;
}
function getLastPrintingRow(sheet, printSettings) {
    var rowEnd, printSettings_rowEnd = printSettings.rowEnd(), sheet_rowCount = sheet.getRowCount();
    if (printSettings_rowEnd === -1) {
        var lastRow = void 0;
        if (printSettings.useMax()) {
            var lastDirtyRow_1 = getLastNonEmptyRow(sheet);
            var lastFBDirtyRow = getLastFloatingObjectDirtyIndex(sheet, true);
            var lastSPDirtyRow = -1;
            if (sheet.shapes) {
                lastSPDirtyRow = sheet.shapes._getRowLastShapeDirtyIndex();
            }
            if (!(!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 0)) {
                var pivotTables = sheet.pivotTables._pivotTables;
                pivotTables.forEach(function (pt) {
                    if (pt._isEmpty()) {
                       
                        var ptPosition = pt.position();
                        if (lastDirtyRow_1 <= ptPosition.row + 18 - 1) {
                            lastDirtyRow_1 = ptPosition.row + 18 - 1;
                        }
                    }
                });
            }
            lastRow = Math_max(lastDirtyRow_1, lastFBDirtyRow, lastSPDirtyRow);
            var lastSpanDirtyRow = _getLastSpanDirtyRow(sheet);
            lastRow = Math_max(lastRow, lastSpanDirtyRow);
        }
        else {
            lastRow = sheet_rowCount - 1;
        }
        rowEnd = lastRow;
    }
    else {
        rowEnd = printSettings_rowEnd;
    }
    rowEnd = Math_min(rowEnd, sheet_rowCount - 1);
    return rowEnd;
}
function resetPageInfoProp(dictObj, pageInfo) {
    $_each(dictObj, function (p) {
        pageInfo[p] = function (value) {
            if (arguments.length === 0) {
                return this['_' + p];
            }
            this['_' + p] = value;
            return this;
        };
    });
}


var PageInfoPropertyDict = {
    headerSize: 0,
    contentSize: 0,
    contentOffset: 0,
    itemStart: -1,
    itemEnd: -1,
    repeatItemStart: -1,
    repeatItemEnd: -1
};
var PageInfo =  (function () {
    function PageInfo() {
        var self = this;
        $_each(PageInfoPropertyDict, function (p, v) {
            self['_' + p] = v;
        });
    }
    return PageInfo;
}());
var PageInfoPrototype = {};
resetPageInfoProp(PageInfoPropertyDict, PageInfoPrototype);
$_extend(PageInfo.prototype, PageInfoPrototype);


var SheetPageInfoPropertyDict = {
    sheetIndex: -1,
    pageNumber: -1,
    columnPageIndex: -1,
    rowPageIndex: -1,
    pageNumberInSheet: -1,
    columnPageIndexInSheet: -1,
    rowPageIndexInSheet: -1,
    columnPage: keyword_null,
    rowPage: keyword_null,
    paperSize: keyword_null,
    pageImageableArea: keyword_null,
    workbookName: str_empty,
    worksheetName: str_empty
};
var SheetPageInfo =  (function () {
    function SheetPageInfo() {
        var self = this;
        $_each(SheetPageInfoPropertyDict, function (p, v) {
            if (p === 'columnPage' || p === 'rowPage') {
                v = new PageInfo();
            }
            else if (p === str_paperSize) {
                v = { width: 0, height: 0 };
            }
            else if (p === 'pageImageableArea') {
                v = new Core_1.Rect(0, 0, 0, 0);
            }
            self['_' + p] = v;
        });
    }
    SheetPageInfo.prototype.getPageSize = function () {
        var columnPage = this.columnPage(), rowPage = this.rowPage();
        return {
            width: columnPage.contentSize() + columnPage.headerSize(),
            height: rowPage.contentSize() + rowPage.headerSize()
        };
    };
    return SheetPageInfo;
}());
exports.SheetPageInfo = SheetPageInfo;
var SheetPageInfoPrototype = {};
resetPageInfoProp(SheetPageInfoPropertyDict, SheetPageInfoPrototype);
$_extend(SheetPageInfo.prototype, SheetPageInfoPrototype);

var WorksheetPaginator =  (function () {
    function WorksheetPaginator(workbook, sheetIndex, paperSize, pageImageableArea) {
        var self = this;
        self._workbook = workbook;
        self._sheet = _getWorksheet(workbook, sheetIndex);
        self._sheetIndex = sheetIndex;
        self._printSettings = self._sheet.printInfo();
        self._paperSize = paperSize;
        self._pageImageableArea = pageImageableArea;
        self._pageSize = { width: pageImageableArea.width, height: pageImageableArea.height };
        self._pageCount = 0;
        self._columnPages = [];
        self._rowPages = [];
        self._horizontalZoomFactor = 1;
        self._verticalZoomFactor = 1;
        self._ignoreVerticalPaginate = false;
        self._ignoreHorizontalPaginate = false;
    }
    WorksheetPaginator.prototype.paginate = function () {
        var self = this;
        if (!self._sheet.visible() || self._contentWidth() <= 0 || self._contentHeight() <= 0) {
            self._pageCount = 0;
            return;
        }
        var printSettings = self._printSettings, fitPagesTall = printSettings.fitPagesTall(), fitPagesWide = printSettings.fitPagesWide();
        if (fitPagesTall === -1 && fitPagesWide === -1) {
            var zoomFactor = printSettings.zoomFactor();
            self.horizontalZoomFactor(zoomFactor);
            self.verticalZoomFactor(zoomFactor);
        }
        var ignoreVerticalPaginate = self._ignoreVerticalPaginate, ignoreHorizontalPaginate = self._ignoreHorizontalPaginate;
       
        if (!ignoreVerticalPaginate) {
            self._rowHeightCache = {};
        }
        if (!ignoreHorizontalPaginate) {
            self._colWidthCache = {};
        }
       
        self._initPivotTablePrintSetting();
        self._paginateCore();
        if (fitPagesTall >= 1 || fitPagesWide >= 1) {
            var totalContentWidth = 0, totalContentHeight = 0;
            for (var col = 0, hPageCount = self.horizontalPageCount(); col < hPageCount; col++) {
                totalContentWidth += self._columnPages[col].contentSize();
            }
            for (var row = 0, vPageCount = self.verticalPageCount(); row < vPageCount; row++) {
                totalContentHeight += self._rowPages[row].contentSize();
            }
            var verticalPageCount = self.verticalPageCount();
            if (fitPagesTall < verticalPageCount && fitPagesTall >= 1) {
                self._verticalFitPaginate(totalContentHeight, verticalPageCount);
            }
            var horizontalPageCount = self.horizontalPageCount();
            if (fitPagesWide < horizontalPageCount && fitPagesWide >= 1) {
                self._horizontalFitPaginate(totalContentWidth, horizontalPageCount);
            }
            self._pageCount = self.verticalPageCount() * self.horizontalPageCount();
        }
       
        if (!ignoreVerticalPaginate) {
            self._rowHeightCache = {};
        }
        if (!ignoreHorizontalPaginate) {
            self._colWidthCache = {};
        }
    };
    WorksheetPaginator.prototype.pageCount = function () {
        return this._pageCount;
    };
    WorksheetPaginator.prototype.getPage = function (pageIndex) {
        var self = this;
        var rowPageIndex = 0;
        var colPageIndex = 0;
        var pageOrder = self._printSettings.pageOrder(), verticalPageCount = self.verticalPageCount(), horizontalPageCount = self.horizontalPageCount();
        if (pageOrder === 1  || pageOrder === 0  && verticalPageCount >= horizontalPageCount) {
            rowPageIndex = pageIndex % verticalPageCount;
            colPageIndex = Math_floor(pageIndex / verticalPageCount);
        }
        else {
            colPageIndex = pageIndex % horizontalPageCount;
            rowPageIndex = Math_floor(pageIndex / horizontalPageCount);
        }
        var sheetPageInfo = new SheetPageInfo();
        sheetPageInfo.sheetIndex(self._sheetIndex);
        sheetPageInfo.pageNumberInSheet(pageIndex);
        sheetPageInfo.rowPageIndexInSheet(rowPageIndex);
        sheetPageInfo.columnPageIndexInSheet(colPageIndex);
        sheetPageInfo.pageNumber(pageIndex);
        sheetPageInfo.rowPageIndex(rowPageIndex);
        sheetPageInfo.columnPageIndex(colPageIndex);
        sheetPageInfo.rowPage(self._rowPages[rowPageIndex]);
        sheetPageInfo.columnPage(self._columnPages[colPageIndex]);
        sheetPageInfo.paperSize(self._paperSize);
        sheetPageInfo.pageImageableArea(self._pageImageableArea);
        sheetPageInfo.workbookName(self._sheet.parent.name);
        sheetPageInfo.worksheetName(self._sheet.name());
        return sheetPageInfo;
    };
    WorksheetPaginator.prototype.verticalZoomFactor = function (value) {
        if (arguments.length === 0) {
            return this._verticalZoomFactor;
        }
        this._verticalZoomFactor = value;
       
        this._rowHeightCache = {};
        return this;
    };
    WorksheetPaginator.prototype.horizontalZoomFactor = function (value) {
        if (arguments.length === 0) {
            return this._horizontalZoomFactor;
        }
        this._horizontalZoomFactor = value;
       
        this._colWidthCache = {};
        return this;
    };
    WorksheetPaginator.prototype.horizontalPageCount = function () {
        return this._columnPages.length;
    };
    WorksheetPaginator.prototype.verticalPageCount = function () {
        return this._rowPages.length;
    };
    WorksheetPaginator.prototype.sheetIndex = function () {
        return this._sheetIndex;
    };
    WorksheetPaginator.prototype._contentWidth = function () {
        return this._pageSize.width;
    };
    WorksheetPaginator.prototype._contentHeight = function () {
        return this._pageSize.height;
    };
    WorksheetPaginator.prototype._paginateCore = function () {
        var self = this;
        if (!self._ignoreVerticalPaginate) {
           
            self._verticalPaginate();
        }
        if (!self._ignoreHorizontalPaginate) {
           
            self._horizontalPaginate();
        }
       
        self._pageCount = self.verticalPageCount() * self.horizontalPageCount();
    };
    WorksheetPaginator.prototype._horizontalFitPaginate = function (totalContentWidth, hPageCount) {
        var self = this;
        var fitPagesWide = self._printSettings.fitPagesWide();
        var minHorizontalZoomFactor = 1.0;
        if (fitPagesWide < hPageCount) {
            minHorizontalZoomFactor = fitPagesWide / hPageCount;
        }
        var maxHorizontalZoomFactor = fitPagesWide * self._contentWidth() / totalContentWidth;
        var horizontalZoomFactor = maxHorizontalZoomFactor;
        var magicNumber = 15;
        var delta = (maxHorizontalZoomFactor - minHorizontalZoomFactor) / magicNumber;
        for (var i = 0; i <= magicNumber; i++) {
            self.horizontalZoomFactor(horizontalZoomFactor);
            self._horizontalPaginate();
            if (self.horizontalPageCount() === fitPagesWide) {
                break;
            }
            horizontalZoomFactor -= delta;
        }
    };
    WorksheetPaginator.prototype._verticalFitPaginate = function (totalContentHeight, vPageCount) {
        var self = this;
        var fitPagesTall = self._printSettings.fitPagesTall();
        var minVerticalZoomFactor = 1.0;
        if (fitPagesTall < vPageCount) {
            minVerticalZoomFactor = fitPagesTall / vPageCount;
        }
        var maxVerticalZoomFactor = fitPagesTall * self._contentHeight() / totalContentHeight;
        var verticalZoomFactor = maxVerticalZoomFactor;
        var magicNumber = 15;
        var delta = (maxVerticalZoomFactor - minVerticalZoomFactor) / magicNumber;
        for (var i = 0; i <= magicNumber; i++) {
            self.verticalZoomFactor(verticalZoomFactor);
            self._verticalPaginate();
            if (self.verticalPageCount() === fitPagesTall) {
                break;
            }
            verticalZoomFactor -= delta;
        }
    };
    WorksheetPaginator.prototype._initPivotTablePrintSetting = function () {
        var sheet = this._sheet;
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 0) {
            return;
        }
        var pivotTables = sheet.pivotTables._pivotTables;
       
       
        pivotTables.forEach(function (pt) {
           
            pt.options.showFilter = false;
            if (!pt.options.printDrill) {
                pt.options.showDrill = false;
            }
           
           
           
            if ((pt._layoutType === 2  && pt.options.mergeItem) || pt.options.fillDownLabels || pt._layoutType === 0 ) {
                pt.options.itemPrintTitles = false;
            }
           
           
            if (pivotTables.length > 1) {
                pt.options.fieldPrintTitles = false;
            }
        });
    };
    WorksheetPaginator.prototype._horizontalPaginate = function () {
        var self = this, printSettings = self._printSettings, sheet = self._sheet, tempColumnStart = printSettings.columnStart();
        var columnStart = tempColumnStart === -1 ? 0 : tempColumnStart;
        var columnEnd = getLastPrintingColumn(sheet, printSettings);
        if (columnEnd === -1) {
            return;
        }
        var rowHeaderWidth = self._getRowHeaderWidth(), contentWidth = self._contentWidth();
        var repeatColumnStart = printSettings.repeatColumnStart(), repeatColumnEnd = printSettings.repeatColumnEnd(), showRowHeader = printSettings.showRowHeader();
        var pageBreakArray = [];
        for (var columnIndex = columnStart; columnIndex <= columnEnd; columnIndex++) {
            if (sheet.getColumnPageBreak(columnIndex)) {
                pageBreakArray.push(columnIndex);
            }
        }
        self._columnPages = [];
        var prePageEnd = -1;
        var columnStartColumnEndArray = _splitByPageBreak(columnStart, columnEnd, pageBreakArray);
        for (var index = 0, length_3 = columnStartColumnEndArray.length; index < length_3 - 1; index += 2) {
            var eachColumnStart = columnStartColumnEndArray[index], eachColumnEnd = columnStartColumnEndArray[index + 1];
            var columnPages = [];
            if (showRowHeader === 2  || showRowHeader === 0  && sheet.options.rowHeaderVisible) {
                columnPages = self._horizontalPaginateCore(eachColumnStart, eachColumnEnd, repeatColumnStart, repeatColumnEnd, 3 , contentWidth - rowHeaderWidth, prePageEnd);
                for (var i = 0, count = columnPages.length; i < count; i++) {
                    columnPages[i].headerSize(rowHeaderWidth);
                }
            }
            else if (showRowHeader === 3 ) {
                var tpPages = self._horizontalPaginateCore(eachColumnStart, eachColumnEnd, repeatColumnStart, repeatColumnEnd, 3 , contentWidth - rowHeaderWidth, prePageEnd);
                if (tpPages.length > 0) {
                    tpPages[0].headerSize(rowHeaderWidth);
                    columnPages.push(tpPages[0]);
                    if (tpPages.length > 1) {
                        tpPages = self._horizontalPaginateCore(tpPages[1].itemStart(), eachColumnEnd, repeatColumnStart, repeatColumnEnd, 3 , contentWidth, tpPages[0].itemEnd());
                        columnPages = columnPages.concat(tpPages);
                    }
                }
            }
            else {
                columnPages = self._horizontalPaginateCore(eachColumnStart, eachColumnEnd, repeatColumnStart, repeatColumnEnd, 3 , contentWidth, prePageEnd);
            }
            self._columnPages = self._columnPages.concat(columnPages);
            if (columnPages.length > 0) {
                prePageEnd = columnPages[columnPages.length - 1].itemEnd();
            }
        }
    };
    WorksheetPaginator.prototype._verticalPaginate = function () {
        var self = this, printSettings = self._printSettings, sheet = self._sheet, tempRowStart = printSettings.rowStart();
        var rowStart = tempRowStart === -1 ? 0 : tempRowStart;
        var rowEnd = getLastPrintingRow(sheet, printSettings);
        if (rowEnd === -1) {
            return;
        }
        var columnHeaderHeight = self._getColumnHeaderHeight(), contentHeight = self._contentHeight();
        var repeatRowStart = printSettings.repeatRowStart(), repeatRowEnd = printSettings.repeatRowEnd(), showColumnHeader = printSettings.showColumnHeader();
        var pageBreakArray = [];
        for (var rowIndex = rowStart; rowIndex <= rowEnd; rowIndex++) {
            if (sheet.getRowPageBreak(rowIndex)) {
                pageBreakArray.push(rowIndex);
            }
        }
        self._rowPages = [];
        var prePageEnd = -1;
        var rowStartRowEndArray = _splitByPageBreak(rowStart, rowEnd, pageBreakArray);
        for (var index = 0, length_4 = rowStartRowEndArray.length; index < length_4 - 1; index += 2) {
            var eachRowStart = rowStartRowEndArray[index], eachRowEnd = rowStartRowEndArray[index + 1];
            var rowPages = [];
            if (showColumnHeader === 2  || showColumnHeader === 0  && sheet.options.colHeaderVisible) {
                rowPages = self._verticalPaginateCore(eachRowStart, eachRowEnd, repeatRowStart, repeatRowEnd, 3 , contentHeight - columnHeaderHeight, prePageEnd);
                for (var i = 0, count = rowPages.length; i < count; i++) {
                    rowPages[i].headerSize(columnHeaderHeight);
                }
            }
            else if (showColumnHeader === 3 ) {
                var tpPages = self._verticalPaginateCore(eachRowStart, eachRowEnd, repeatRowStart, repeatRowEnd, 3 , contentHeight - columnHeaderHeight, prePageEnd);
                if (tpPages.length > 0) {
                    tpPages[0].headerSize(columnHeaderHeight);
                    rowPages.push(tpPages[0]);
                    if (tpPages.length > 1) {
                        tpPages = self._verticalPaginateCore(tpPages[1].itemStart(), eachRowEnd, repeatRowStart, repeatRowEnd, 3 , contentHeight, tpPages[0].itemEnd());
                        rowPages = rowPages.concat(tpPages);
                    }
                }
            }
            else {
                rowPages = self._verticalPaginateCore(eachRowStart, eachRowEnd, repeatRowStart, repeatRowEnd, 3 , contentHeight, prePageEnd);
            }
            self._rowPages = self._rowPages.concat(rowPages);
            if (rowPages.length > 0) {
                prePageEnd = rowPages[rowPages.length - 1].itemEnd();
            }
        }
    };
    WorksheetPaginator.prototype._getRowHeaderWidth = function () {
        var self = this, rowHeaderPages = self._horizontalPaginateCore(0, self._sheet.getColumnCount(2 ) - 1, -1, -1, 2 , self._contentWidth(), -1);
        var rowHeaderWidth = 0;
        for (var i = 0; i < rowHeaderPages.length; i++) {
            rowHeaderWidth += rowHeaderPages[i].contentSize();
        }
        return rowHeaderWidth;
    };
    WorksheetPaginator.prototype._getColumnHeaderHeight = function () {
        var self = this, columnHeaderPages = self._verticalPaginateCore(0, self._sheet.getRowCount(1 ) - 1, -1, -1, 1 , self._contentHeight(), -1);
        var columnHeaderWidth = 0;
        for (var i = 0; i < columnHeaderPages.length; i++) {
            columnHeaderWidth += columnHeaderPages[i].contentSize();
        }
        return columnHeaderWidth;
    };
    WorksheetPaginator.prototype._isValidRepeatColumnOrRow = function (isColumn, start, end, repeatStart, repeatEnd, sheetArea, pageSize) {
        var self = this, size;
        if (sheetArea === 3 ) {
           
            var repeatSize = 0;
            for (var i = repeatStart; i <= repeatEnd; i++) {
                size = isColumn ? self._getColumnWidth(i, sheetArea) : self._getRowHeight(i, sheetArea);
                repeatSize += size;
            }
           
            var maxSize = 0;
            for (var k = start; k <= end; k++) {
                if (k > repeatEnd) {
                    size = isColumn ? self._getColumnWidth(k, sheetArea) : self._getRowHeight(k, sheetArea);
                    if (maxSize < size) {
                        maxSize = size;
                    }
                }
            }
           
            if (repeatSize + maxSize > pageSize) {
                return false;
            }
        }
        return true;
    };
    WorksheetPaginator.prototype._calcRowRepetHeadrRange = function () {
        var sheet = this._sheet, repeatColumnStart = -1, repeatColumnEnd = -1;
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length !== 1 || !sheet.pivotTables._pivotTables[0].options.fieldPrintTitles) {
            return { repeatColumnStart: repeatColumnStart, repeatColumnEnd: repeatColumnEnd };
        }
        var pt = sheet.pivotTables._pivotTables[0], ptPosition = pt.position(), ptRowModel = pt._dataModel._models[3 ];
        return { repeatColumnStart: ptPosition.col + ptRowModel._startCol, repeatColumnEnd: ptPosition.col + ptRowModel._startCol + ptRowModel._colCount - 1 };
    };
    WorksheetPaginator.prototype._horizontalPaginateCore = function (columnStart, columnEnd, repeatColumnStart, repeatColumnEnd, sheetArea, pageWidth, prePageEnd) {
        var self = this;
        if (repeatColumnStart === -1 || repeatColumnEnd === -1) {
            var repetRange = this._calcRowRepetHeadrRange();
            repeatColumnStart = repetRange.repeatColumnStart;
            repeatColumnEnd = repetRange.repeatColumnEnd;
        }
        if (!self._isValidRepeatColumnOrRow(true, columnStart, columnEnd, repeatColumnStart, repeatColumnEnd, sheetArea, pageWidth)) {
            repeatColumnStart = -1;
            repeatColumnEnd = -1;
        }
        var handleRepeatColumns = repeatColumnStart < columnStart;
        var currentColumnWidth = 0;
        var currentWidth = 0;
        var contentWidth = 0;
        var repeatColumnWidth = 0;
        var tpPageSize = pageWidth;
        var tpRepeatColumnStart;
        var tpRepeatColumnEnd;
        var prePageLastColumnLargeThanPage = false;
        var page = keyword_null;
        var pages = [];
        if (columnStart > columnEnd) {
            var tp = columnStart;
            columnStart = columnEnd;
            columnEnd = tp;
        }
        for (var currentColumn = columnStart; currentColumn <= columnEnd; currentColumn++) {
            if (handleRepeatColumns && sheetArea === 3 ) {
                tpRepeatColumnStart = repeatColumnStart;
                tpRepeatColumnEnd = repeatColumnEnd;
                if (tpRepeatColumnStart !== -1 && tpRepeatColumnStart <= prePageEnd) {
                    if (tpRepeatColumnEnd !== -1 && tpRepeatColumnEnd > prePageEnd) {
                        tpRepeatColumnEnd = prePageEnd - 1;
                    }
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(repeatColumnStart);
                    page.repeatItemEnd(repeatColumnEnd);
                    for (var i = tpRepeatColumnStart; i <= tpRepeatColumnEnd; i++) {
                        var columnWith = self._getColumnWidth(i, sheetArea);
                        if (i <= prePageEnd) {
                            repeatColumnWidth += columnWith;
                        }
                    }
                    tpPageSize -= repeatColumnWidth;
                    handleRepeatColumns = false;
                }
            }
            currentColumnWidth = self._getColumnWidth(currentColumn, sheetArea);
            if (currentColumnWidth > tpPageSize && (prePageLastColumnLargeThanPage || currentColumn === columnStart)) {
                prePageLastColumnLargeThanPage = false;
                var totalPaginatedColumnWidth = 0;
                while (currentColumnWidth - totalPaginatedColumnWidth >= tpPageSize) {
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(repeatColumnStart);
                    page.repeatItemEnd(repeatColumnEnd);
                    page.itemStart(currentColumn);
                    page.itemEnd(currentColumn);
                    page.contentSize(pageWidth);
                    page.contentOffset(totalPaginatedColumnWidth);
                    pages.push(page);
                   
                    totalPaginatedColumnWidth += tpPageSize;
                    page = keyword_null;
                    currentWidth = 0;
                   
                   
                    handleRepeatColumns = true;
                }
                var remainingWidth = currentColumnWidth - totalPaginatedColumnWidth;
               
                if (remainingWidth === 0) {
                    prePageEnd = currentColumn;
                    continue;
                }
                else {
                    prePageEnd = currentColumn - 1;
                }
                if (currentColumn === columnEnd) {
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(repeatColumnStart);
                    page.repeatItemEnd(repeatColumnEnd);
                    page.itemStart(currentColumn);
                    page.itemEnd(currentColumn);
                    page.contentSize(remainingWidth + repeatColumnWidth);
                    page.contentOffset(totalPaginatedColumnWidth);
                    pages.push(page);
                    break;
                }
                else {
                   
                    currentColumn++;
                    if (currentColumn <= columnEnd) {
                        if (page === keyword_null) {
                            page = new PageInfo();
                        }
                        page.repeatItemStart(repeatColumnStart);
                        page.repeatItemEnd(repeatColumnEnd);
                        currentWidth = remainingWidth;
                        page.contentOffset(totalPaginatedColumnWidth);
                        currentColumnWidth = self._getColumnWidth(currentColumn, sheetArea);
                    }
                    else {
                        break;
                    }
                }
            }
            currentWidth += currentColumnWidth;
            if (currentWidth > tpPageSize || currentWidth === tpPageSize) {
                if (currentWidth > tpPageSize) {
                    contentWidth = currentWidth - currentColumnWidth + repeatColumnWidth;
                    currentColumn -= 1;
                }
                else {
                    contentWidth = currentWidth + repeatColumnWidth;
                }
                if (page === keyword_null) {
                    page = new PageInfo();
                }
                if (prePageEnd === -1) {
                    page.itemStart(columnStart);
                }
                else {
                    page.itemStart(prePageEnd + 1);
                }
                page.itemEnd(currentColumn);
                page.contentSize(contentWidth);
                pages.push(page);
                page = keyword_null;
                currentWidth = 0;
                repeatColumnWidth = 0;
                tpPageSize = pageWidth;
                handleRepeatColumns = true;
                prePageEnd = currentColumn;
                if (currentColumnWidth > tpPageSize) {
                    prePageLastColumnLargeThanPage = true;
                }
            }
            else if (currentColumn === columnEnd) {
                if (page === keyword_null) {
                    page = new PageInfo();
                }
                contentWidth = currentWidth + repeatColumnWidth;
                if (prePageEnd === -1) {
                    page.itemStart(columnStart);
                }
                else {
                    page.itemStart(prePageEnd + 1);
                }
                page.itemEnd(currentColumn);
                page.contentSize(contentWidth);
                pages.push(page);
                page = keyword_null;
                currentWidth = 0;
                repeatColumnWidth = 0;
                tpPageSize = pageWidth;
                handleRepeatColumns = true;
            }
        }
        sheetArea === 3 && this._repeatColumnLabelsWithPivotTable(pages);
        return pages;
    };
    WorksheetPaginator.prototype._repeatColumnLabelsWithPivotTable = function (pages) {
        var sheet = this._sheet;
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 1 || pages.length < 2) {
            return;
        }
        var pivotTables = sheet.pivotTables._pivotTables;
        for (var i = 0; i < pivotTables.length; i++) {
            var pt = pivotTables[i];
            if (!pt.options.itemPrintTitles) {
                continue;
            }
            for (var j = 1; j < pages.length; j++) {
                var ptPosition = pt.position(), ptRowModel = pt._dataModel._models[2 ], page = pages[j];
                var col = page._itemStart, row = ptPosition.row + ptRowModel._startRow;
                for (var k = 1; k < ptRowModel._rowCount; k++) {
                    var value = sheet.getValue(row + k, col, 3 );
                    if (value === null) {
                        while (value === null) {
                            col = col - 1;
                            value = sheet.getValue(row + k, col, 3 );
                        }
                       
                       
                       
                       
                        sheet.setValue(row + k, page._itemStart, value, 3);
                        col = page._itemStart;
                    }
                    else {
                        break;
                    }
                }
            }
        }
    };
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
    WorksheetPaginator.prototype._calcColumnRepetHeadrRange = function () {
        var sheet = this._sheet, repeatRowStart = -1, repeatRowEnd = -1;
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length !== 1 || !sheet.pivotTables._pivotTables[0].options.fieldPrintTitles) {
            return { repeatRowStart: repeatRowStart, repeatRowEnd: repeatRowEnd };
        }
        var pt = sheet.pivotTables._pivotTables[0], ptPosition = pt.position(), ptRowModel = pt._dataModel._models[2 ];
        return { repeatRowStart: ptPosition.row + ptRowModel._startRow, repeatRowEnd: ptPosition.row + ptRowModel._startRow + ptRowModel._rowCount - 1 };
    };
    WorksheetPaginator.prototype._verticalPaginateCore = function (rowStart, rowEnd, repeatRowStart, repeatRowEnd, sheetArea, pageHeight, prePageEnd) {
        var self = this;
        if (repeatRowStart === -1 || repeatRowEnd === -1) {
            var repetRange = this._calcColumnRepetHeadrRange();
            repeatRowStart = repetRange.repeatRowStart;
            repeatRowEnd = repetRange.repeatRowEnd;
        }
        if (!self._isValidRepeatColumnOrRow(false, rowStart, rowEnd, repeatRowStart, repeatRowEnd, sheetArea, pageHeight)) {
            repeatRowStart = -1;
            repeatRowEnd = -1;
        }
        var handleRepeatColumns = repeatRowStart < rowStart;
        var currentRowHeight = 0;
        var currentHeight = 0;
        var contentHeight = 0;
        var repeatRowHeight = 0.0;
        var tpPageSize = pageHeight;
        var tpRepeatRowStart;
        var tpRepeatRowEnd = repeatRowEnd;
        var prePageLastRowLargeThanPage = false;
        var page = keyword_null;
        var pages = [];
        if (rowStart > rowEnd) {
            var tp = rowStart;
            rowStart = rowEnd;
            rowEnd = tp;
        }
        for (var currentRow = rowStart; currentRow <= rowEnd; currentRow++) {
            if (handleRepeatColumns && sheetArea === 3 ) {
                tpRepeatRowStart = repeatRowStart;
                tpRepeatRowEnd = repeatRowEnd;
                if (tpRepeatRowStart !== -1 && tpRepeatRowStart <= prePageEnd) {
                    if (tpRepeatRowEnd !== -1 && tpRepeatRowEnd > prePageEnd) {
                        tpRepeatRowEnd = prePageEnd - 1;
                    }
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(tpRepeatRowStart);
                    page.repeatItemEnd(tpRepeatRowEnd);
                    for (var i = tpRepeatRowStart; i <= tpRepeatRowEnd; i++) {
                        var rowHeight = self._getRowHeight(i, sheetArea);
                        if (i <= prePageEnd) {
                            repeatRowHeight += rowHeight;
                        }
                    }
                    tpPageSize -= repeatRowHeight;
                    handleRepeatColumns = false;
                }
            }
            currentRowHeight = self._getRowHeight(currentRow, sheetArea);
            if (currentRowHeight > tpPageSize && (prePageLastRowLargeThanPage || currentRow === rowStart)) {
                prePageLastRowLargeThanPage = false;
                var totalPaginatedRowHeight = 0;
                while (currentRowHeight - totalPaginatedRowHeight >= tpPageSize) {
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(repeatRowStart);
                    page.repeatItemEnd(tpRepeatRowEnd);
                    page.itemStart(currentRow);
                    page.itemEnd(currentRow);
                    page.contentSize(pageHeight);
                    page.contentOffset(totalPaginatedRowHeight);
                    pages.push(page);
                   
                    totalPaginatedRowHeight += tpPageSize;
                    page = keyword_null;
                    currentHeight = 0;
                   
                   
                    handleRepeatColumns = true;
                }
                var remainingHeight = currentRowHeight - totalPaginatedRowHeight;
               
                if (remainingHeight === 0) {
                    prePageEnd = currentRow;
                    continue;
                }
                else {
                    prePageEnd = currentRow - 1;
                }
                if (currentRow === rowEnd) {
                    if (page === keyword_null) {
                        page = new PageInfo();
                    }
                    page.repeatItemStart(repeatRowStart);
                    page.repeatItemEnd(repeatRowEnd);
                    page.itemStart(currentRow);
                    page.itemEnd(currentRow);
                    page.contentSize(remainingHeight + repeatRowHeight);
                    page.contentOffset(totalPaginatedRowHeight);
                    pages.push(page);
                    break;
                }
                else {
                    currentRow++;
                    if (currentRow <= rowEnd) {
                        if (page === keyword_null) {
                            page = new PageInfo();
                        }
                        page.repeatItemStart(repeatRowStart);
                        page.repeatItemEnd(tpRepeatRowEnd);
                        currentHeight = remainingHeight;
                        page.contentOffset(totalPaginatedRowHeight);
                        currentRowHeight = self._getRowHeight(currentRow, sheetArea);
                    }
                    else {
                        break;
                    }
                }
            }
            currentHeight += currentRowHeight;
            if (currentHeight > tpPageSize || currentHeight === tpPageSize) {
                if (currentHeight > tpPageSize) {
                    contentHeight = currentHeight - currentRowHeight + repeatRowHeight;
                    currentRow -= 1;
                }
                else {
                    contentHeight = currentHeight + repeatRowHeight;
                }
                if (page === keyword_null) {
                    page = new PageInfo();
                }
                if (prePageEnd === -1) {
                    page.itemStart(rowStart);
                }
                else {
                    page.itemStart(prePageEnd + 1);
                }
                page.itemEnd(currentRow);
                page.contentSize(contentHeight);
                pages.push(page);
                page = keyword_null;
                currentHeight = 0;
                repeatRowHeight = 0;
                tpPageSize = pageHeight;
                handleRepeatColumns = true;
                prePageEnd = currentRow;
                if (currentRowHeight > tpPageSize) {
                    prePageLastRowLargeThanPage = true;
                }
            }
            else if (currentRow === rowEnd) {
                if (page === keyword_null) {
                    page = new PageInfo();
                }
                contentHeight = currentHeight + repeatRowHeight;
                if (prePageEnd === -1) {
                    page.itemStart(rowStart);
                }
                else {
                    page.itemStart(prePageEnd + 1);
                }
                page.itemEnd(currentRow);
                page.contentSize(contentHeight);
                pages.push(page);
                page = keyword_null;
                currentHeight = 0;
                repeatRowHeight = 0;
                tpPageSize = pageHeight;
                handleRepeatColumns = true;
            }
        }
       
        sheetArea === 3 && this._repeatRowLabelsWithPivotTable(pages);
        return pages;
    };
    WorksheetPaginator.prototype._repeatRowLabelsWithPivotTable = function (pages) {
        var sheet = this._sheet;
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 1 || pages.length < 2) {
            return;
        }
        var pivotTables = sheet.pivotTables._pivotTables;
        for (var i = 0; i < pivotTables.length; i++) {
            var pt = pivotTables[i];
            if (!pt.options.itemPrintTitles) {
                continue;
            }
            for (var j = 1; j < pages.length; j++) {
                var ptPosition = pt.position(), ptRowModel = pt._dataModel._models[3 ], page = pages[j];
                var row = page._itemStart, col = ptPosition.col + ptRowModel._startCol;
                for (var k = 0; k < ptRowModel._colCount; k++) {
                    var value = sheet.getValue(row, col + k, 3 );
                    if (value === null) {
                        while (value === null) {
                            row = row - 1;
                            value = sheet.getValue(row, col + k, 3 );
                        }
                       
                       
                       
                       
                        sheet.setValue(page._itemStart, col + k, value, 3);
                        row = page._itemStart;
                    }
                    else {
                        break;
                    }
                }
            }
        }
    };
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
    WorksheetPaginator.prototype._getColumnWidthCore = function (c, sheetArea) {
        var self = this, sheet = self._sheet, defaults = sheet.defaults;
        var isVisible = sheet.getColumnVisible(c, sheetArea);
        if (sheetArea === 3  && c < sheet.getColumnCount() && sheet.columnOutlines) {
            isVisible = isVisible && !sheet.columnOutlines.isCollapsed(c);
        }
        var columnWidth = 0;
        if (isVisible) {
            columnWidth = sheet.getColumnWidth(c, sheetArea);
            if (self._printSettings.bestFitColumns()) {
                var isRowHeader = sheetArea === 2 ;
                var autoFitValue = Core_1._util._getColumnAutoFitValue(c, sheet, isRowHeader ? 2  : 3 , 1 );
                if (autoFitValue <= 0) {
                    if (isRowHeader) {
                        columnWidth = defaults.rowHeaderColWidth;
                    }
                    else {
                        columnWidth = defaults.colWidth;
                    }
                }
                else {
                    columnWidth = autoFitValue;
                }
            }
        }
        return columnWidth;
    };
    WorksheetPaginator.prototype._getColumnWidth = function (c, sheetArea) {
        var self = this;
        var cache = self._colWidthCache[sheetArea];
        if (!cache) {
            cache = self._colWidthCache[sheetArea] = {};
        }
        var width = cache[c];
        if (isUndefined(width)) {
            width = cache[c] = self._getColumnWidthCore(c, sheetArea) * self._horizontalZoomFactor;
        }
        return width;
    };
    WorksheetPaginator.prototype._getRowHeightCore = function (r, sheetArea) {
        var self = this, sheet = self._sheet, defaults = sheet.defaults, defaultRowHeight = defaults.rowHeight, defaultColHeaderRowHeight = defaults.colHeaderRowHeight;
        var isVisible = sheet.getRowVisible(r, sheetArea);
        if (sheetArea === 3  && r < sheet.getRowCount() && sheet.rowOutlines) {
            isVisible = isVisible && !(sheet._isRowFilterOut && sheet._isRowFilterOut(r)) && !sheet.rowOutlines.isCollapsed(r);
        }
        var rowHeight = 0;
        if (isVisible) {
            rowHeight = sheet.getRowHeight(r, sheetArea);
            if (self._printSettings.bestFitRows()) {
                var isColumnHeader = sheetArea === 1 ;
                var autoFitValue = Core_1._util._getRowAutoFitValue(r, sheet, isColumnHeader ? 1  : 3 , 1 );
                if (autoFitValue <= 0) {
                    if (isColumnHeader) {
                        rowHeight = defaultColHeaderRowHeight;
                    }
                    else {
                        rowHeight = defaultRowHeight;
                    }
                }
                else {
                    var height = autoFitValue;
                    if (isColumnHeader) {
                        if (height < defaultColHeaderRowHeight) {
                            height = defaultColHeaderRowHeight;
                        }
                    }
                    else if (height < defaultRowHeight) {
                        height = defaultRowHeight;
                    }
                    rowHeight = height;
                }
            }
        }
        return rowHeight;
    };
    WorksheetPaginator.prototype._getRowHeight = function (r, sheetArea) {
        var self = this;
        var cache = self._rowHeightCache[sheetArea];
        if (!cache) {
            cache = self._rowHeightCache[sheetArea] = {};
        }
        var height = cache[r];
        if (isUndefined(height)) {
            height = cache[r] = self._getRowHeightCore(r, sheetArea) * self._verticalZoomFactor;
        }
        return height;
    };
    return WorksheetPaginator;
}());
exports.WorksheetPaginator = WorksheetPaginator;
function _splitByPageBreak(start, end, pageBreakArray) {
    var result = [], i, length, index;
    result.push(start);
    length = pageBreakArray.length;
    for (i = 0; i < length; i++) {
        index = pageBreakArray[i];
        if (index - 1 >= start) {
            result.push(index - 1);
            result.push(index);
        }
    }
    result.push(end);
    return result;
}

var WorkbookPaginator =  (function () {
    function WorkbookPaginator(workbook) {
        this._workbook = workbook;
        this._pageCount = 0;
        var sheetPaginators = [], i, count, sheet, outParam;
        count = _getWorksheetCount(workbook);
        for (i = 0; i < count; i++) {
            sheet = _getWorksheet(workbook, i);
            if (sheet.visible()) {
                outParam = {};
                initPrintingSize(sheet, sheet.printInfo(), outParam);
                sheetPaginators.push(new WorksheetPaginator(workbook, i, outParam.paperSize, outParam.pageImageableArea));
            }
        }
        this._sheetPaginators = sheetPaginators;
    }
    WorkbookPaginator.prototype.paginate = function () {
        var self = this, sheetPaginators = self._sheetPaginators, i = sheetPaginators.length, paginator;
        while (i) {
            i--;
            paginator = sheetPaginators[i];
            paginator.paginate();
            self._pageCount += paginator.pageCount();
        }
    };
    WorkbookPaginator.prototype.pageCount = function () {
        return this._pageCount;
    };
    WorkbookPaginator.prototype.getPage = function (pageNumber) {
        var outParam = { pageNumberInSheet: -1 };
        var sheetPaginator = this.getSheetPaginator(pageNumber, outParam);
        var pageNumberInSheet = outParam.pageNumberInSheet;
        var sheetPageInfo = keyword_null;
        if (sheetPaginator) {
            sheetPageInfo = sheetPaginator.getPage(pageNumberInSheet);
            if (sheetPageInfo.sheetIndex() > 0) {
                sheetPageInfo.pageNumber(pageNumber);
                var sheetPaginators = this._sheetPaginators;
                for (var i = 0, count = sheetPaginators.length; i < count; i++) {
                    var paginator = sheetPaginators[i];
                    if (sheetPageInfo.sheetIndex() < paginator.sheetIndex()) {
                        sheetPageInfo.rowPageIndex(sheetPageInfo.rowPageIndexInSheet() + paginator.verticalPageCount());
                        sheetPageInfo.columnPageIndex(sheetPageInfo.columnPageIndexInSheet() + paginator.horizontalPageCount());
                    }
                }
            }
        }
        return sheetPageInfo;
    };
    WorkbookPaginator.prototype.getSheetPaginator = function (pageNumber, outParam) {
        var currentTotalCount = 0;
        var pageNumberInSheet = -1;
        var sheetPaginators = this._sheetPaginators;
        for (var i = 0, count = sheetPaginators.length; i < count; i++) {
            var paginator = sheetPaginators[i];
            pageNumberInSheet = pageNumber - currentTotalCount;
            if (pageNumberInSheet >= 0 && pageNumberInSheet < paginator.pageCount()) {
                outParam.pageNumberInSheet = pageNumberInSheet;
                return paginator;
            }
            currentTotalCount += paginator.pageCount();
        }
        return keyword_null;
    };
    return WorkbookPaginator;
}());
exports.WorkbookPaginator = WorkbookPaginator;

var ChartsProcessor =  (function () {
    function ChartsProcessor(charts) {
        this._charts = charts;
    }
    ChartsProcessor.prototype._processAChart = function (container, chart) {
        var div = document.createElement("div");
        div.style.width = chart.width() + "px";
        div.style.height = chart.height() + "px";
        container.appendChild(div);
        chart._initFlexDV(div, chart.sheet().printInfo().qualityFactor(), false);
        var canvas = div.getElementsByTagName("canvas")[0];
        chart._dispose();
        chart._canvas = canvas;
    };
    ChartsProcessor.prototype._processAllCharts = function () {
        var self = this;
        var container = self._container;
        if (!container) {
            container = self._container = document.createElement("div");
            container.style.width = "0px";
            container.style.height = "0px";
            container.style.overflow = "hidden";
            document.body.appendChild(container);
        }
        self._charts.forEach(function (chart) {
            self._processAChart(container, chart);
        });
        container.innerHTML = "";
    };
    ChartsProcessor.prototype._dispose = function () {
        var self = this;
        self._charts = keyword_null;
        var container = self._container;
        if (container) {
            if (container.parentElement) {
                container.parentElement.removeChild(container);
            }
            self._container = keyword_null;
        }
    };
    return ChartsProcessor;
}());


function _getIframeDocument(iframe) {
    var doc = iframe.contentDocument;
    if (!doc.head) {
        doc.write('<head></head>');
    }
    if (!doc.body) {
        doc.write('<body></body>');
    }
    return doc;
}
function _getSheetPaginator(paginator, pageNumber) {
    var sheetPaginator;
    if (paginator instanceof WorksheetPaginator) {
        sheetPaginator = paginator;
    }
    else if (paginator instanceof WorkbookPaginator) {
        sheetPaginator = paginator.getSheetPaginator(pageNumber, {});
    }
    return sheetPaginator;
}
function _createContainer(doc, width, height, className) {
    var div = createElement(doc, str_div);
    var divStyle = div.style;
    divStyle.border = '1px transparent solid';
    divStyle.boxSizing = 'border-box';
    divStyle.width = width + str_px;
    divStyle.height = height + str_px;
    divStyle.position = "relative";
    div.className = className;
    doc.body.appendChild(div);
    return div;
}
function _createContentContainer(doc, container, width, height, marginLeft, marginTop) {
    var contentContainer = createElement(doc, str_div);
    var contentContainerStyle = contentContainer.style;
    contentContainerStyle.marginLeft = marginLeft + str_px;
    contentContainerStyle.width = width + str_px;
    contentContainerStyle.marginTop = marginTop + str_px;
    contentContainerStyle.height = height + str_px;
    container.appendChild(contentContainer);
    return contentContainer;
}
function _addHeader(doc, width, height, qualityFactor) {
    var canvas = createElement(doc, str_canvas);
    var $headerCanvas = $(canvas);
    var canvasStyle = canvas.style;
    canvasStyle.height = height + str_px;
    canvasStyle.width = width + str_px;
    canvas.width = $headerCanvas.width() * qualityFactor;
    canvas.height = $headerCanvas.height() * qualityFactor;
    canvas.getContext(str_2d).scale(qualityFactor, qualityFactor);
    return canvas;
}
function _addFooter(doc, width, height, qualityFactor) {
    var canvas = createElement(doc, str_canvas);
    var $footerCanvas = $(canvas);
    var canvasStyle = canvas.style;
    canvasStyle.height = height + str_px;
    canvasStyle.width = width + str_px;
    canvas.width = $footerCanvas.width() * qualityFactor;
    canvas.height = $footerCanvas.height() * qualityFactor;
    canvas.getContext(str_2d).scale(qualityFactor, qualityFactor);
    return canvas;
}
function _createBodyContainer(doc, container, width, height) {
    var bodyContainer = createElement(doc, str_div);
    var bodyContainerStyle = bodyContainer.style;
    bodyContainerStyle.width = width + str_px;
    bodyContainerStyle.height = height + str_px;
    container.appendChild(bodyContainer);
    return bodyContainer;
}
function _addBody(sheet, doc, container, width, height, showBorder, centering, zoomFactor, qualityFactor) {
    var borderWidth = 0;
    var BORDER_BOX = 'border-box';
    if (showBorder) {
        borderWidth = 1;
    }
    else {
        var sheetAreaOffset = sheet.options.sheetAreaOffset;
        width += sheetAreaOffset.left;
        height += sheetAreaOffset.top;
    }
    var containerStyle = container.style;
    if (centering === 1  || centering === 3 ) {
        containerStyle.boxSizing = BORDER_BOX;
        containerStyle.paddingLeft = ($(container).width() - width - borderWidth * 2) / 2 + str_px;
    }
    if (centering === 2  || centering === 3 ) {
        containerStyle.boxSizing = BORDER_BOX;
        containerStyle.paddingTop = ($(container).height() - height - borderWidth * 2) / 2 + str_px;
    }
    var div = createElement(doc, str_div);
    var divStyle = div.style;
    divStyle.width = width + str_px;
    divStyle.height = height + str_px;
    divStyle.border = borderWidth + 'px black solid';
    var canvas = createElement(doc, str_canvas);
    var canvasStyle = canvas.style;
    canvasStyle.margin = borderWidth + str_px;
    canvas.width = 1 / zoomFactor * (width - 2 * borderWidth);
    canvas.height = 1 / zoomFactor * (height - 2 * borderWidth);
    canvasStyle.width = (width - 2 * borderWidth) + str_px;
    canvasStyle.height = (height - 2 * borderWidth) + str_px;
    var scaleX = qualityFactor, scaleY = qualityFactor;
    if (Sheets_util_browser.chrome) {
        var pixelPointCount = canvas.width * scaleX * canvas.height * scaleY;
        while (pixelPointCount < 65792) {
            pixelPointCount *= 2;
            scaleY *= 2;
        }
    }
    canvas._actualWidth = canvas.width;
    canvas._actualHeight = canvas.height;
    canvas.width *= scaleX;
    canvas.height *= scaleY;
    canvas.getContext(str_2d).scale(scaleX, scaleY);
    container.appendChild(div);
    return canvas;
}
function _generateHeaderFooterContents(pageNumber, source, image, sheetPageInfo, pageCount, firstPageNumber) {
    var contents = [];
    if (!source) {
        return contents;
    }
    var COMMAND_PREFIX = '&', COLOR_PREFIX = 'K', STRIKETHROUGH_PREFIX = 'S', UNDERLINE_PREFIX = 'U', FONT_PREFIX = '"', BOLD_PREFIX = 'B', ITALIC_PREFIX = 'I', DATE_PREFIX = 'D', TIME_PREFIX = 'T', CURRENT_PAGE_PREFIX = 'P', PAGE_COUNT_PREFIX = 'N', PICTURE_PREFIX = 'G', WORKBOOK_NAME_CMD_PREFIX = 'F', WORKSHEET_NAME_CMD_PREFIX = 'A';
    var COMMAND_PREFIX_LENGTH = COMMAND_PREFIX.length;
    var FONT_SIZE_REGEX = /&[0-9]+/;
    var RGB_COLOR_REGEX = /&K[0-9A-Fa-f]{6}/;
    var FONT_REGEX = /&".+"/;
    var fontName = str_empty, isStrikethrough = false, fontSize = 0, isBold = false, isItalic = false, isUnderline = false, foreground = 'black';
    var text = str_empty;
    while (source) {
        var fontNameNext = fontName;
        var isStrikethroughNext = isStrikethrough;
        var fontSizeNext = fontSize;
        var isUnderlineNext = isUnderline;
        var isBoldNext = isBold;
        var isItalicNext = isItalic;
        var foregroundNext = foreground;
        var index = source.indexOf(COMMAND_PREFIX);
        if (index < 0) {
            index = source.length;
        }
        text += source.substr(0, index);
        var cmd = index + 1 < source.length ? source.substr(index + 1, 1) : str_empty;
        cmd = cmd.toUpperCase();
        var nextIndex = -1;
        var submit = false;
        var submitImage = false, result = void 0, firstMatch = void 0, now = new Date();
        if ('1234567890'.indexOf(cmd) > -1) {
           
            result = FONT_SIZE_REGEX.exec(source.substr(index));
            if (result && result.length > 0) {
                firstMatch = result[0];
                fontSizeNext = parseFloatFn(firstMatch.substr(1));
                submit = true;
                nextIndex = index + firstMatch.length;
            }
            else {
                nextIndex = index + COMMAND_PREFIX_LENGTH;
            }
        }
        else if (cmd === COLOR_PREFIX) {
           
            result = RGB_COLOR_REGEX.exec(source.substr(index));
            if (result && result.length > 0) {
                firstMatch = result[0];
                foregroundNext = '#' + firstMatch.substr(2, 2) + firstMatch.substr(4, 2) + firstMatch.substr(6, 2);
                submit = true;
                nextIndex = index + firstMatch.length;
            }
            else {
                nextIndex = index + COMMAND_PREFIX_LENGTH;
            }
        }
        else if (cmd === STRIKETHROUGH_PREFIX) {
            isStrikethroughNext = !isStrikethroughNext;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + STRIKETHROUGH_PREFIX.length;
        }
        else if (cmd === UNDERLINE_PREFIX) {
            isUnderlineNext = !isUnderlineNext;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + UNDERLINE_PREFIX.length;
        }
        else if (cmd === FONT_PREFIX) {
           
            result = FONT_REGEX.exec(source.substr(index));
            if (result && result.length > 0) {
                firstMatch = result[0];
                fontNameNext = firstMatch.substr(2, firstMatch.length - 3);
                submit = true;
                nextIndex = index + firstMatch.length;
            }
            else {
                nextIndex = index + COMMAND_PREFIX_LENGTH;
            }
        }
        else if (cmd === BOLD_PREFIX) {
            isBoldNext = !isBoldNext;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + BOLD_PREFIX.length;
        }
        else if (cmd === ITALIC_PREFIX) {
            isItalicNext = !isItalicNext;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + ITALIC_PREFIX.length;
        }
        else if (cmd === COMMAND_PREFIX) {
            text += COMMAND_PREFIX;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + COMMAND_PREFIX_LENGTH;
        }
        else if (cmd === DATE_PREFIX) {
            text += now.getFullYear() + '/' + (now.getMonth() + 1) + '/' + now.getDate();
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + DATE_PREFIX.length;
        }
        else if (cmd === TIME_PREFIX) {
            text += now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds();
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + TIME_PREFIX.length;
        }
        else if (cmd === CURRENT_PAGE_PREFIX) {
            text += pageNumber;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + CURRENT_PAGE_PREFIX.length;
        }
        else if (cmd === PAGE_COUNT_PREFIX) {
           
            text += (pageCount + firstPageNumber - 1) ;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + PAGE_COUNT_PREFIX.length;
        }
        else if (cmd === PICTURE_PREFIX) {
            if (image) {
                submit = true;
                submitImage = true;
            }
            nextIndex = index + COMMAND_PREFIX_LENGTH + PICTURE_PREFIX.length;
        }
        else if (cmd === WORKBOOK_NAME_CMD_PREFIX) {
            text += sheetPageInfo.workbookName() || str_empty;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + WORKBOOK_NAME_CMD_PREFIX.length;
        }
        else if (cmd === WORKSHEET_NAME_CMD_PREFIX) {
            text += sheetPageInfo.worksheetName() || str_empty;
            submit = true;
            nextIndex = index + COMMAND_PREFIX_LENGTH + WORKSHEET_NAME_CMD_PREFIX.length;
        }
        else {
            nextIndex = index + COMMAND_PREFIX_LENGTH;
        }
        if (nextIndex >= source.length) {
            source = str_empty;
        }
        else {
            if (nextIndex < 0) {
                nextIndex = index + COMMAND_PREFIX_LENGTH;
            }
            source = source.substr(nextIndex);
        }
        if (text && (submit || !source)) {
            contents.push({
                text: text,
                underline: isUnderline,
                strikethrough: isStrikethrough,
                fontFamily: fontName,
                fontSize: fontSize > 0 ? fontSize + str_px : str_empty,
                fontWeight: isBold ? 'bold' : str_empty,
                fontStyle: isItalic ? 'italic' : str_empty,
                color: foreground
            });
            text = str_empty;
        }
        if (submitImage && image) {
            contents.push({ image: image });
        }
        fontName = fontNameNext;
        isStrikethrough = isStrikethroughNext;
        fontSize = fontSizeNext;
        isUnderline = isUnderlineNext;
        isBold = isBoldNext;
        isItalic = isItalicNext;
        foreground = foregroundNext;
    }
    return contents;
}
function _renderHeaderFooterContents(ctx, contents, x, y, width, height, horizontalAlign, verticalAlign, imageLoader) {
    var lines = [];
    var processedContents = [];
    for (var i = 0, count = contents.length; i < count; i++) {
        var tempContent = contents[i], text = tempContent.text;
        if (text) {
            var containRN = text.indexOf('\r\n') >= 0;
            if (containRN || text.indexOf('\n') >= 0) {
                var textArray = containRN ? text.split('\r\n') : text.split('\n');
                if (textArray[0]) {
                    processedContents.push($_extend({}, tempContent, { text: textArray[0] }));
                }
                lines.push(processedContents);
                processedContents = [];
                for (var j = 1, length_5 = textArray.length; j < length_5 - 1; j++) {
                    if (textArray[j]) {
                        lines.push([$_extend({}, tempContent, { text: textArray[j] })]);
                    }
                }
                if (textArray[textArray.length - 1]) {
                    processedContents.push($_extend({}, tempContent, { text: textArray[textArray.length - 1] }));
                }
            }
            else {
                processedContents.push(tempContent);
            }
        }
        else {
            processedContents.push(tempContent);
        }
    }
    if (processedContents.length > 0) {
        lines.push(processedContents);
       
    }
    for (var k = 0, lineCount = lines.length; k < lineCount; k++) {
        _renderHeaderFooterContentsImp(ctx, lines[k], x, y + k * height / lineCount, width, height / lineCount, horizontalAlign, verticalAlign, imageLoader);
    }
}
function _renderHeaderFooterContentsImp(ctx, contents, x, y, width, height, horizontalAlign, verticalAlign, imageLoader) {
    var fontArray = [], textHeightArray = [], textWidthArray = [];
    var imageSize = Math_min(width, height) - 2;
    var startX = x;
    if (horizontalAlign === 1 ) {
        startX = x + width / 2;
    }
    else if (horizontalAlign === 2 ) {
        startX = x + width;
    }
    var maxHeight = imageSize, i, count, textWidth, textHeight, tempContent, image, text;
    count = contents.length;
    for (i = 0; i < count; i++) {
        tempContent = contents[i];
        image = tempContent.image;
        text = tempContent.text;
        var fontFamily = tempContent.fontFamily, fontSize = tempContent.fontSize, fontWeight = tempContent.fontWeight, fontStyle = tempContent.fontStyle;
        if (image) {
            if (horizontalAlign === 1 ) {
                startX -= imageSize / 2;
            }
            else if (horizontalAlign === 2 ) {
                startX -= imageSize;
            }
        }
        else if (text) {
            var font = _buildFontString(fontFamily, fontSize, fontWeight, fontStyle);
            fontArray[i] = font;
            Core_1._util._setContextFont(ctx, font);
            textHeight = parseFloatFn(fontSize || '13.3px');
            if (maxHeight < textHeight) {
                maxHeight = textHeight;
            }
            textHeightArray[i] = textHeight;
            textWidth = ctx.measureText(text).width;
            textWidthArray[i] = textWidth;
            if (horizontalAlign === 1 ) {
                startX -= textWidth / 2;
            }
            else if (horizontalAlign === 2 ) {
                startX -= textWidth;
            }
        }
    }
    var startY = y + maxHeight / 2;
    if (verticalAlign === 1 ) {
        startY = y + height / 2;
    }
    else if (verticalAlign === 2 ) {
        startY = y + height - maxHeight / 2;
    }
    ctx.save();
    ctx.textAlign = 'left';
    ctx.textBaseline = 'middle';
    count = contents.length;
    for (i = 0; i < count; i++) {
        tempContent = contents[i];
        image = tempContent.image;
        text = tempContent.text;
        var underline = tempContent.underline, strikethrough = tempContent.strikethrough, color = tempContent.color;
        if (image) {
            _paintImage(ctx, imageLoader, image, startX, startY - imageSize / 2, imageSize, imageSize);
            startX += imageSize;
        }
        else if (text) {
            ctx.beginPath();
            ctx.font = fontArray[i];
            ctx.fillStyle = color;
            ctx.fillText(text, startX, startY);
            textHeight = textHeightArray[i];
            textWidth = textWidthArray[i];
            if (underline || strikethrough) {
                ctx.beginPath();
                ctx.moveTo(startX, strikethrough ? startY : startY + textHeight / 2);
                ctx.lineTo(startX + textWidth, strikethrough ? startY : startY + textHeight / 2);
                ctx.stroke();
            }
            startX += textWidth;
        }
    }
    ctx.restore();
}
function _paintImage(ctx, imageLoader, imageSrc, destX, destY, destWidth, destHeight, backColor) {
    if (imageLoader._getState(imageSrc)) {
        var bkImg = imageLoader._getImage(imageSrc);
        try {
            if (backColor) {
                ctx.save();
                ctx.fillStyle = backColor;
                ctx.fillRect(destX, destY, destWidth, destHeight);
                ctx.restore();
            }
            ctx.drawImage(bkImg, 0, 0, bkImg.width, bkImg.height, destX, destY, destWidth, destHeight);
        }
        catch (ex) {
           
        }
    }
    else {
        imageLoader._addImage(imageSrc);
    }
}
function _buildFontString(fontFamily, fontSize, fontWeight, fontStyle) {
    if (!fontFamily) {
        fontFamily = 'Arial';
    }
    if (!fontSize) {
        fontSize = '13.3px';
    }
    var f = str_empty;
    var normal = 'normal';
    var str_space = ' ';
    var defaultFontWeight = '400';
    if (fontStyle !== normal) {
        f = fontStyle;
    }
    if (fontWeight !== normal && fontWeight !== defaultFontWeight) {
        f += (f ? str_space : str_empty) + fontWeight;
    }
    f += (f ? str_space : str_empty) + fontSize;
    f += str_space + fontFamily;
    return f;
}
function _paintPicturesImp(sheet, ctx, clipRect, rowViewportIndex, colViewportIndex, imageLoader, printZoomFactor) {
    var cachePool = sheet._cachePool, colLayouts = sheet._getViewportColumnLayout(colViewportIndex), rowLayouts = sheet._getViewportRowLayout(rowViewportIndex), viewportLeftColLayout = colLayouts[0], viewportRightColLayout = colLayouts[colLayouts.length - 1], viewportTopRowLayout = rowLayouts[0], viewportBottomRowLayout = rowLayouts[rowLayouts.length - 1];
    iteratePicturesAndCharts(sheet, function (floatingObject) {
        if (floatingObject.isVisible() && floatingObject.canPrint()) {
           
            var x = 0, y = 0, width = floatingObject.width() * printZoomFactor, height = floatingObject.height() * printZoomFactor;
            var startColumn = floatingObject.startColumn(), startColumnLayout = colLayouts.findCol(startColumn);
            if (startColumnLayout) {
                x = startColumnLayout.x;
            }
            else if (startColumn < viewportLeftColLayout.col) {
                x = viewportLeftColLayout.x;
                for (var c = viewportLeftColLayout.col - 1; c >= startColumn; c--) {
                    x -= cachePool._getZoomColWidth(c);
                }
            }
            else {
               
               
               
                x = viewportRightColLayout.x;
                for (var col = viewportRightColLayout.col; col < startColumn; col++) {
                    x += cachePool._getZoomColWidth(col);
                }
            }
            x += floatingObject.startColumnOffset() * printZoomFactor;
            var startRow = floatingObject.startRow(), startRowLayout = rowLayouts.findRow(startRow);
            if (startRowLayout) {
                y = startRowLayout.y;
            }
            else if (startRow < viewportTopRowLayout.row) {
                y = viewportTopRowLayout.y;
                for (var r = viewportTopRowLayout.row - 1; r >= startRow; r--) {
                    y -= cachePool._getZoomRowHeight(r);
                }
            }
            else {
                y = viewportBottomRowLayout.y;
                for (var row = viewportBottomRowLayout.row; row < startRow; row++) {
                    y += cachePool._getZoomRowHeight(row);
                }
            }
            y += floatingObject.startRowOffset() * printZoomFactor;
           
            if (clipRect && clipRect.intersect(x, y, width, height)) {
                ctx.save();
                ctx.rect(clipRect.x, clipRect.y, clipRect.width, clipRect.height);
                ctx.clip();
                ctx.beginPath();
                if (floatingObject.typeName === '1' ) {
                    var backColor = floatingObject.backColor();
                    var src = floatingObject._rotatedSrc || floatingObject.src();
                    if (src) {
                        _paintImage(ctx, imageLoader, src, x, y, width, height, backColor);
                    }
                }
                else if (floatingObject.typeName === '2' ) {
                    var canvas = floatingObject._canvas;
                    if (canvas) {
                        try {
                            ctx.drawImage(canvas, 0, 0, canvas.width, canvas.height, x, y, width, height);
                        }
                        catch (ex) {
                           
                        }
                    }
                }
                ctx.restore();
            }
        }
    });
}
function _adjustStartColumnOffsetAfterHideColumn(sheet, column) {
    var offsetArray = [], columnWidth = sheet._getActualColumnWidth(column);
    iteratePicturesAndCharts(sheet, function (floatingObject) {
        if (floatingObject.startColumn() <= column && column <= floatingObject.endColumn()) {
            offsetArray.push({ type: "startColumnOffset", floatingObject: floatingObject, floatingObjectOffset: floatingObject.startColumnOffset() });
            floatingObject.startColumnOffset(floatingObject.startColumnOffset() - columnWidth);
        }
    });
    return offsetArray;
}
function _adjustStartRowOffsetAfterHideRow(sheet, row) {
    var offsetArray = [], rowHeight = sheet._getActualRowHeight(row);
    iteratePicturesAndCharts(sheet, function (floatingObject) {
        if (floatingObject.startRow() <= row && row <= floatingObject.endRow()) {
            offsetArray.push({ type: "startRowOffset", floatingObject: floatingObject, floatingObjectOffset: floatingObject.startRowOffset() });
            floatingObject.startRowOffset(floatingObject.startRowOffset() - rowHeight);
        }
    });
    return offsetArray;
}
function _autoFitColumn(sheet, columns, isRowHeader, autoFitType) {
    sheet._commandManager().execute({ cmd: 'autoFitColumn', sheetName: sheet.name(), columns: columns, rowHeader: isRowHeader, autoFitType: autoFitType });
}
function _autoFitRow(sheet, rows, isColHeader, autoFitType) {
    sheet._commandManager().execute({ cmd: 'autoFitRow', sheetName: sheet.name(), rows: rows, columnHeader: isColHeader, autoFitType: autoFitType });
}
function _createAlternativeImgElement(doc, canvas, imageLoader, needMargin) {
    var src = canvas.toDataURL();
    var imgElement = doc.createElement('img');
    if (needMargin) {
        imgElement.style.margin = canvas.style.margin;
    }
    imgElement.style.width = canvas.style.width;
    imgElement.style.height = canvas.style.height;
    imgElement.src = src;
    if (!imageLoader._getState(src)) {
        imageLoader._addImage(src);
    }
    return imgElement;
}
function calcPageNumbers(paginator, workbook) {
    var pageNumbers = [];
    var pageNum = 1, sheetIndex = -1;
    for (var index = 0, pageCount = paginator.pageCount(); index < pageCount; index++) {
        var sheetPageInfo = paginator.getPage(index);
        var currentSheetIndex = sheetPageInfo.sheetIndex();
        if (sheetIndex !== currentSheetIndex) {
            var sheet = _getWorksheet(workbook, currentSheetIndex);
            var printInfo = sheet.printInfo();
            var firstPageNumber = printInfo.firstPageNumber();
            if (firstPageNumber !== 1 || printInfo._isFirstPageNumberSet) {
                pageNum = firstPageNumber;
            }
            sheetIndex = currentSheetIndex;
        }
        pageNumbers[index] = pageNum;
        pageNum++;
    }
    return pageNumbers;
}
var _PrintPagePresenter =  (function () {
    function _PrintPagePresenter(workbook, paginator) {
       
        this._cache = {};
        this._workbook = workbook;
        this._paginator = paginator;
    }
    _PrintPagePresenter.prototype.initBuild = function () {
        var self = this;
        var doc = _getIframeDocument(self._getIframe());
        doc.open();
        doc.write('<head><style>body{margin:0} .gc-printPage{page-break-after: always} .grayscale{filter: grayscale(100%)}</style></head><body></body>');
        doc.close();
    };
    _PrintPagePresenter.prototype.initContainer = function (paperSize, margin) {
        var self = this;
        var doc = _getIframeDocument(self._getIframe());
        var paperWidth = paperSize.width, paperHeight = paperSize.height;
        var marginLeft = margin.left, marginRight = margin.right, marginTop = margin.top, marginBottom = margin.bottom, marginHeader = margin.header, marginFooter = margin.footer;
        var contentWidth = paperWidth - marginLeft - marginRight, contentHeight = paperHeight - Math_min(marginHeader, marginTop) - Math_min(marginFooter, marginBottom);
        var container = _createContainer(doc, paperWidth, paperHeight, str_printPage);
        self._container = container;
        self._contentContainer = _createContentContainer(doc, container, contentWidth, contentHeight, marginLeft, Math_min(marginHeader, marginTop));
    };
    _PrintPagePresenter.prototype.processHeader = function (contentWidth, headerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber, options) {
        var self = this, contentContainer = self._contentContainer;
        var qualityFactor = options.qualityFactor;
        var doc = _getIframeDocument(self._getIframe());
        var headerCanvas = _addHeader(doc, contentWidth, headerHeight, qualityFactor);
        self._paintHeader(headerCanvas.getContext(str_2d), contentWidth, headerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber);
        contentContainer.appendChild(qualityFactor <= 2 ? headerCanvas : _createAlternativeImgElement(doc, headerCanvas, imageLoader));
    };
    _PrintPagePresenter.prototype._paintHeader = function (ctx, width, height, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber) {
        var firstPageNumber = isNullOrUndefined(printInfo._firstPageNumber) ? 1  : printInfo._firstPageNumber;
        var contentsHeaderLeft = _generateHeaderFooterContents(pageNumber, printInfo.headerLeft(), printInfo.headerLeftImage(), sheetPageInfo, pageCount, firstPageNumber), contentsHeaderCenter, contentsHeaderRight;
        _renderHeaderFooterContents(ctx, contentsHeaderLeft, 0, 0, width / 3, height, 0 , 0 , imageLoader);
        contentsHeaderCenter = _generateHeaderFooterContents(pageNumber, printInfo.headerCenter(), printInfo.headerCenterImage(), sheetPageInfo, pageCount, firstPageNumber);
        _renderHeaderFooterContents(ctx, contentsHeaderCenter, width / 3, 0, width / 3, height, 1 , 0 , imageLoader);
        contentsHeaderRight = _generateHeaderFooterContents(pageNumber, printInfo.headerRight(), printInfo.headerRightImage(), sheetPageInfo, pageCount, firstPageNumber);
        _renderHeaderFooterContents(ctx, contentsHeaderRight, width / 3 * 2, 0, width / 3, height, 2 , 0 , imageLoader);
    };
    _PrintPagePresenter.prototype.processBody = function (sheet, bodyWidth, bodyHeight, imageLoader, options, sheetPageInfo, printInfo) {
        var self = this, contentContainer = self._contentContainer;
        var qualityFactor = options.qualityFactor, contentWidth = options.contentWidth, bodyContentHeight = options.bodyContentHeight, showBorder = options.showBorder, centering = options.centering;
        var doc = _getIframeDocument(self._getIframe());
        var bodyContainer = _createBodyContainer(doc, contentContainer, contentWidth, bodyContentHeight);
        var zoomFactor = printInfo.zoomFactor(), printZoomFactor = 1, sheetPaginator = options.sheetPaginator, fitPagesWide = printInfo.fitPagesWide(), fitPagesTall = printInfo.fitPagesTall();
        if (fitPagesWide !== -1 || fitPagesTall !== -1) {
            var horizontalZoomFactor = sheetPaginator.horizontalZoomFactor(), verticalZoomFactor = sheetPaginator.verticalZoomFactor();
            printZoomFactor = Math.min(horizontalZoomFactor, verticalZoomFactor);
            zoomFactor = 1;
        }
        var canvas = _addBody(sheet, doc, bodyContainer, bodyWidth, bodyHeight, showBorder, centering, zoomFactor, qualityFactor);
        var canvas_context = canvas.getContext(str_2d), canvas_width = canvas._actualWidth, canvas_height = canvas._actualHeight;
        self._paintBody(sheet, canvas_context, new Core_1.Rect(0, 0, canvas_width, canvas_height), imageLoader, printZoomFactor);
        self._paintPictures(sheet, canvas_context, new Core_1.Rect(0, 0, canvas_width, canvas_height), imageLoader, printZoomFactor);
        self._paintEmptyPivotTable(sheet, canvas_context, new Core_1.Rect(0, 0, canvas_width, canvas_height), options, sheetPageInfo);
        if (sheet.shapes) {
            sheet.shapes._paintShapesForPrint(sheet, canvas_context, new Core_1.Rect(0, 0, canvas_width, canvas_height), printZoomFactor);
        }
        var canvasParent = bodyContainer.children[0];
        canvasParent.appendChild(qualityFactor <= 2 ? canvas : _createAlternativeImgElement(doc, canvas, imageLoader, true));
    };
    _PrintPagePresenter.prototype._paintEmptyPivotTable = function (sheet, ctx, clipRect, options, sheetPageInfo) {
        if (!sheet.pivotTables || !sheet.pivotTables._pivotTables || sheet.pivotTables._pivotTables.length < 0) {
            return;
        }
        var pivotTables = sheet.pivotTables._pivotTables;
        pivotTables.forEach(function (pt) {
            if (pt._isEmpty()) {
               
                var ptPosition = pt.position(), rect = void 0;
                var pageRange = { rowStart: sheetPageInfo._rowPage._itemStart, rowEnd: sheetPageInfo._rowPage._itemEnd, colStart: sheetPageInfo._columnPage._itemStart, colEnd: sheetPageInfo._columnPage._itemEnd };
                if (ptPosition.row >= pageRange.rowStart && ptPosition.row <= pageRange.rowEnd && ptPosition.col >= pageRange.colStart && ptPosition.col <= pageRange.colEnd) {
                    rect = sheet.getRangeRect(1, 1, { row: ptPosition.row, col: ptPosition.col, rowCount: 18, colCount: 3 });
                }
                else if (ptPosition.row + 18 - 1 >= pageRange.rowStart && ptPosition.row + 18 - 1 <= pageRange.rowEnd && ptPosition.col >= pageRange.colStart && ptPosition.col <= pageRange.colEnd) {
                    rect = sheet.getRangeRect(1, 1, { row: pageRange.rowStart, col: ptPosition.col, rowCount: ptPosition.row + 18 - 1 - pageRange.rowStart + 1, colCount: 3 });
                }
                else if (ptPosition.row >= pageRange.rowStart && ptPosition.row <= pageRange.rowEnd && ptPosition.col + 3 - 1 >= pageRange.colStart && ptPosition.col + 3 - 1 <= pageRange.colEnd) {
                    rect = sheet.getRangeRect(1, 1, { row: ptPosition.row, col: pageRange.colStart, rowCount: 18, colCount: ptPosition.col + 3 - 1 - pageRange.colStart + 1 });
                }
                else if (ptPosition.row + 18 - 1 >= pageRange.rowStart && ptPosition.row + 18 - 1 <= pageRange.rowEnd && ptPosition.col + 3 - 1 >= pageRange.colStart && ptPosition.col + 3 - 1 <= pageRange.colEnd) {
                    rect = sheet.getRangeRect(1, 1, { row: pageRange.rowStart, col: pageRange.colStart, rowCount: ptPosition.row + 18 - 1 - pageRange.rowStart + 1, colCount: ptPosition.col + 3 - 1 - pageRange.colStart + 1 });
                }
                if (rect) {
                    var oldCanvasStrokeStyle = ctx.strokeStyle;
                    ctx.strokeStyle = 'black';
                    ctx.rect(options.marginLeft + rect.x - sheetPageInfo._columnPage._headerSize, options.marginHeader + rect.y - sheetPageInfo._rowPage._headerSize, rect.width, rect.height);
                    ctx.stroke();
                    ctx.strokeStyle = oldCanvasStrokeStyle;
                }
            }
        });
    };
    _PrintPagePresenter.prototype._paintBody = function (sheet, ctx, rect, imageLoader, printZoomFactor) {
        sheet._imageLoader = imageLoader;
        sheet._setBounds(rect);
        sheet.invalidateLayout();
        sheet._render._paintSheetForPrint(ctx, rect, printZoomFactor);
    };
    _PrintPagePresenter.prototype._paintPictures = function (sheet, ctx, clipRect, imageLoader, printZoomFactor) {
        var sheetLayout = sheet._getSheetLayout();
        for (var r = 0; r <= 2; r++) {
            for (var c = 0; c <= 2; c++) {
                var intersectRect = clipRect.getIntersectRect(sheetLayout._viewportRect(r, c));
                if (intersectRect) {
                    _paintPicturesImp(sheet, ctx, intersectRect, r, c, imageLoader, printZoomFactor);
                }
            }
        }
    };
    _PrintPagePresenter.prototype._processWatermarks = function (imageLoader, watermarks, paperWidth, paperHeight, printInfo) {
        var DPI = 0.96;
        var self = this, container = self._container;
        var doc = _getIframeDocument(self._getIframe());
        var canvas = createElement(doc, str_canvas);
        canvas.style.position = "absolute";
        canvas.style.left = '0px';
        canvas.style.top = '0px';
        canvas.style.zIndex = "-1";
        canvas.width = paperWidth;
        canvas.height = paperHeight;
        watermarks.forEach(function (waterItem) {
            var x = waterItem.x, y = waterItem.y, width = waterItem.width, height = waterItem.height, imageSrc = waterItem.imageSrc;
            _paintImage(canvas.getContext(str_2d), imageLoader, imageSrc, x * DPI, y * DPI, width * DPI, height * DPI);
        });
        container.appendChild(canvas);
    };
    _PrintPagePresenter.prototype._transtlateWatermarkData = function (watermarks) {
        var data = {};
        for (var i = 0; i < watermarks.length; i++) {
            var item = watermarks[i];
            var page = item.page;
            if (page === 'all' || page === 'odd' || page === 'even') {
                data[page] = data[page] || [];
                data[page].push(item);
            }
            else if (!isNullOrUndefined(page)) {
                var pages = page.split(',');
                for (var j = 0; j < pages.length; j++) {
                    var pageIndex = pages[j];
                    data[pageIndex] = data[pageIndex] || [];
                    data[pageIndex].push(item);
                }
            }
        }
        return data;
    };
    _PrintPagePresenter.prototype._getWaterMarkItemByPageIndex = function (pageIndex, watermarkObj) {
        var result = [];
        if (watermarkObj.all) {
            result = result.concat(watermarkObj.all);
        }
        if (pageIndex % 2 === 0 && watermarkObj.even) {
            result = result.concat(watermarkObj.even);
        }
        else if (pageIndex % 2 === 1 && watermarkObj.odd) {
            result = result.concat(watermarkObj.odd);
        }
        else if (watermarkObj[pageIndex]) {
            result = result.concat(watermarkObj[pageIndex]);
        }
        return result;
    };
    _PrintPagePresenter.prototype.processFooter = function (contentWidth, footerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber, options) {
        var self = this, contentContainer = self._contentContainer;
        var qualityFactor = options.qualityFactor;
        var doc = _getIframeDocument(self._getIframe());
        var footerCanvas = _addFooter(doc, contentWidth, footerHeight, qualityFactor);
        self._paintFooter(footerCanvas.getContext(str_2d), contentWidth, footerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber);
        contentContainer.appendChild(qualityFactor <= 2 ? footerCanvas : _createAlternativeImgElement(doc, footerCanvas, imageLoader));
    };
    _PrintPagePresenter.prototype._paintFooter = function (ctx, width, height, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumber) {
        var firstPageNumber = isNullOrUndefined(printInfo._firstPageNumber) ? 1  : printInfo._firstPageNumber;
        var contentsFooterLeft = _generateHeaderFooterContents(pageNumber, printInfo.footerLeft(), printInfo.footerLeftImage(), sheetPageInfo, pageCount, firstPageNumber), contentsFooterCenter, contentsFooterRight;
        _renderHeaderFooterContents(ctx, contentsFooterLeft, 0, 0, width / 3, height, 0 , 2 , imageLoader);
        contentsFooterCenter = _generateHeaderFooterContents(pageNumber, printInfo.footerCenter(), printInfo.footerCenterImage(), sheetPageInfo, pageCount, firstPageNumber);
        _renderHeaderFooterContents(ctx, contentsFooterCenter, width / 3, 0, width / 3, height, 1 , 2 , imageLoader);
        contentsFooterRight = _generateHeaderFooterContents(pageNumber, printInfo.footerRight(), printInfo.footerRightImage(), sheetPageInfo, pageCount, firstPageNumber);
        _renderHeaderFooterContents(ctx, contentsFooterRight, width / 3 * 2, 0, width / 3, height, 2 , 2 , imageLoader);
    };
    _PrintPagePresenter.prototype.processBlackAndWhite = function () {
        var container = this._container;
        if (Sheets_util_browser.mozilla) {
            container.classList.add('grayscale');
        }
        else {
            var $canvasList = $(str_canvas, container);
            for (var i = 0, length_6 = $canvasList.length; i < length_6; i++) {
                var canvasItem = $canvasList[i];
                _applyBlackAndWhite(canvasItem.getContext(str_2d), new Core_1.Rect(0, 0, canvasItem.width, canvasItem.height));
            }
        }
    };
    _PrintPagePresenter.prototype.clearAfterBuild = function () {
        var self = this;
        var doc = _getIframeDocument(self._getIframe());
        var lastDiv = doc.body.lastChild;
        if (lastDiv) {
            $(lastDiv).removeClass(str_printPage);
        }
    };
    _PrintPagePresenter.prototype.build = function () {
        var self = this, workbook = self._workbook, paginator = self._paginator;
        var workbookOptions = workbook.options;
        var isChangedBackColor;
       
       
        if (workbookOptions.backColor === 'white' && workbook._backColorChanged === false) {
            isChangedBackColor = true;
            workbook.options.backColor = 'rgba(0,0,0,0)';
        }
        self.initBuild();
        var pageCount = paginator.pageCount();
        var imageLoader = self._getImageLoader();
        self._preProcessCharts();
        var pageNumbers = calcPageNumbers(paginator, workbook);
        var sheetWatermarkCache = {};
        for (var index = 0; index < pageCount; index++) {
            var sheetPageInfo = paginator.getPage(index);
            var sheet = _getWorksheet(workbook, sheetPageInfo.sheetIndex());
            var printInfo = sheet.printInfo();
            var sheetName = sheet.name();
            var watmarkObj = void 0;
            if (!sheetWatermarkCache[sheetName]) {
                var watermark = printInfo.watermark();
                watmarkObj = self._transtlateWatermarkData(watermark);
                sheetWatermarkCache[sheetName] = watmarkObj;
            }
            else {
                watmarkObj = sheetWatermarkCache[sheetName];
            }
            var pageNumberInSheet = sheetPageInfo.pageNumberInSheet();
            var pageRange = printInfo.pageRange();
            if (pageRange) {
                var pageIndexes = getPageRange(pageRange);
                modifyPageIndexes(pageIndexes, pageCount);
                if (pageIndexes.indexOf(pageNumberInSheet) < 0) {
                    continue;
                }
            }
            var changes = self._prepareSheet(sheet, sheetPageInfo);
            var margin = getMargin(printInfo.margin()), marginLeft = margin.left, marginRight = margin.right, marginTop = margin.top, marginBottom = margin.bottom, marginHeader = margin.header, marginFooter = margin.footer;
            var orientation_1 = printInfo.orientation();
            var paperSize = getPaperSize(sheet, printInfo.paperSize(), orientation_1), paperWidth = paperSize.width, paperHeight = paperSize.height;
            var contentWidth = paperWidth - marginLeft - marginRight, contentHeight = paperHeight - Math_min(marginHeader, marginTop) - Math_min(marginFooter, marginBottom);
            var headerHeight = Math_max(0, marginTop - marginHeader);
            var footerHeight = Math_max(0, marginBottom - marginFooter);
            var bodySize = sheetPageInfo.getPageSize(), bodyWidth = bodySize.width, bodyHeight = bodySize.height;
            var processOptions = {
                qualityFactor: printInfo.qualityFactor(),
                marginHeader: marginHeader,
                paperHeight: paperHeight,
                marginFooter: marginFooter,
                contentWidth: contentWidth,
                bodyContentHeight: contentHeight - headerHeight - footerHeight,
                showBorder: printInfo.showBorder(),
                centering: printInfo.centering(),
                marginLeft: marginLeft,
                marginTop: marginTop,
                sheetPaginator: _getSheetPaginator(paginator, index)
            };
           
            self.initContainer(paperSize, margin);
           
            var watermarksForThisPage = self._getWaterMarkItemByPageIndex(pageNumberInSheet, watmarkObj);
            if (watermarksForThisPage.length > 0) {
                self._processWatermarks(imageLoader, watermarksForThisPage, paperWidth, paperHeight, printInfo);
            }
           
            if (headerHeight > 0) {
                self.processHeader(contentWidth, headerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumbers[index], processOptions);
            }
           
            self.processBody(sheet, bodyWidth, bodyHeight, imageLoader, processOptions, sheetPageInfo, printInfo);
           
            if (footerHeight > 0) {
                self.processFooter(contentWidth, footerHeight, printInfo, sheetPageInfo, pageCount, imageLoader, pageNumbers[index], processOptions);
            }
            if (printInfo.blackAndWhite()) {
                self.processBlackAndWhite();
            }
            self._restoreSheet(changes);
            sheet._dispose(false);
        }
        self.clearAfterBuild();
        if (imageLoader._isAllImagesLoaded()) {
            self.onBuildCompleted();
        }
       
        if (isChangedBackColor === true) {
            workbook.options.backColor = 'white';
            workbook._backColorChanged = false;
        }
    };
    _PrintPagePresenter.prototype.print = function () {
        var iframe = this._getIframe(), doc, win;
        if (Sheets_util_browser.msie) {
            doc = _getIframeDocument(iframe);
            doc.execCommand('print');
        }
        else {
            win = iframe.contentWindow;
            win.focus();
            win.print();
        }
        window.focus();
    };
    _PrintPagePresenter.prototype.dispose = function () {
        var self = this, iframe = self._iframe, parentElement = iframe && iframe.parentElement;
        if (parentElement) {
            parentElement.removeChild(iframe);
            self._iframe = keyword_null;
        }
        if (self._imageLoader) {
            self._imageLoader._dispose();
            self._imageLoader = keyword_null;
        }
        if (self._chartsProcessor) {
            self._chartsProcessor._dispose();
            self._chartsProcessor = keyword_null;
        }
        var workbook = self._workbook;
        if (workbook) {
            workbook.destroy();
            self._workbook = keyword_null;
        }
        self._paginator = keyword_null;
       
        self._cache = {};
        self._contentContainer = keyword_null;
        self._container = keyword_null;
    };
    _PrintPagePresenter.prototype._getIframe = function () {
        if (!this._iframe) {
            var DOCUMENT = document;
            var iframe = createElement(DOCUMENT, 'IFRAME');
            var iframeStyle = iframe.style;
            iframeStyle.position = 'absolute';
            iframeStyle.left = '-10px';
            iframeStyle.width = '0px';
            iframeStyle.height = '0px';
            DOCUMENT.body.insertBefore(iframe, keyword_null);
            this._iframe = iframe;
        }
        return this._iframe;
    };
    _PrintPagePresenter.prototype._prepareSheet = function (sheet, sheetPageInfo) {
        var changes = [];
       
        sheet.zoom(1);
        sheet.suspendPaint();
        sheet.suspendEvent();
        sheet.suspendCalcService && sheet.suspendCalcService();
       
        if (sheet.showRowOutline) {
            sheet.showRowOutline(false);
            sheet.showColumnOutline(false);
        }
        var options = sheet.options;
       
        var printInfo = sheet.printInfo();
        var showGridLine = printInfo.showGridLine();
        var gridline = sheet.options.gridline;
        gridline.showHorizontalGridline = showGridLine;
        gridline.showVerticalGridline = showGridLine;
        var self = this;
        if (!self._cache[sheet.name()]) {
            var needUpdatePictures = false;
           
            if (printInfo.bestFitColumns()) {
               
                var printInfo_columnStart = printInfo.columnStart(), columnStart = printInfo_columnStart === -1 ? 0 : printInfo_columnStart;
                var columnEnd = getLastPrintingColumn(sheet, printInfo);
                var columns = [];
                for (var columnIndex = columnStart; columnIndex <= columnEnd; columnIndex++) {
                    columns.push({ col: columnIndex });
                }
                _autoFitColumn(sheet, columns, false, 1 );
               
                var rowHeaderColumns = [];
                var rowHeaderColumnCount = sheet.getColumnCount(2 );
                for (var rowHeaderColumnIndex = 0; rowHeaderColumnIndex < rowHeaderColumnCount; rowHeaderColumnIndex++) {
                    rowHeaderColumns.push({ col: rowHeaderColumnIndex });
                }
                _autoFitColumn(sheet, rowHeaderColumns, true, 1 );
                needUpdatePictures = true;
            }
           
            if (printInfo.bestFitRows()) {
               
                var printInfo_rowStart = printInfo.rowStart(), rowStart = printInfo_rowStart === -1 ? 0 : printInfo_rowStart;
                var rowEnd = getLastPrintingRow(sheet, printInfo);
                var rows = [];
                for (var rowIndex = rowStart; rowIndex <= rowEnd; rowIndex++) {
                    rows.push({ row: rowIndex });
                }
                _autoFitRow(sheet, rows, false, 1 );
               
                var columnHeaderRows = [];
                var columnHeaderRowCount = sheet.getRowCount(1 );
                for (var columnHeaderRowIndex = 0; columnHeaderRowIndex < columnHeaderRowCount; columnHeaderRowIndex++) {
                    columnHeaderRows.push({ row: columnHeaderRowIndex });
                }
                _autoFitRow(sheet, columnHeaderRows, true, 1 );
                needUpdatePictures = true;
            }
            if (needUpdatePictures) {
                iteratePicturesAndCharts(sheet, function (floatingObject) {
                    floatingObject._updateLocationSize();
                });
            }
            self._cache[sheet.name()] = true;
        }
       
        var showRowHeader = printInfo.showRowHeader();
        if (showRowHeader === 0 ) {
           
        }
        else if (showRowHeader === 2  || showRowHeader === 3  && sheetPageInfo.columnPageIndexInSheet() === 0) {
            options.rowHeaderVisible = true;
        }
        else {
            options.rowHeaderVisible = false;
        }
       
        var showColumnHeader = printInfo.showColumnHeader();
        if (showColumnHeader === 0 ) {
           
        }
        else if (showColumnHeader === 2  || showColumnHeader === 3  && sheetPageInfo.rowPageIndexInSheet() === 0) {
            options.colHeaderVisible = true;
        }
        else {
            options.colHeaderVisible = false;
        }
       
        sheet.frozenRowCount(0);
        sheet.frozenColumnCount(0);
        sheet.frozenTrailingRowCount(0);
        sheet.frozenTrailingColumnCount(0);
       
        var rowFilter = sheet._rowFilter;
        if (rowFilter) {
            rowFilter.filterButtonVisible(false);
        }
       
        var tables = sheet.tables && sheet.tables.all(), i, length;
        if (tables) {
            length = tables.length;
            for (i = 0; i < length; i++) {
                tables[i].filterButtonVisible(false);
            }
        }
       
        var columnPage = sheetPageInfo.columnPage(), columnPage_repeatItemStart = columnPage.repeatItemStart(), columnPage_repeatItemEnd = columnPage.repeatItemEnd();
        var hiddenColWidth = 0;
        if (columnPage_repeatItemStart !== -1 && columnPage_repeatItemEnd !== -1) {
            sheet.frozenColumnCount(columnPage_repeatItemEnd + 1);
            length = columnPage_repeatItemStart;
            for (i = 0; i < length; i++) {
                changes.push({ type: "colVisible", sheetName: sheet.name(), index: i, visible: sheet.getColumnVisible(i) });
                sheet.setColumnVisible(i, false);
                hiddenColWidth += sheet._getActualColumnWidth(i);
                var columnOffsetArray = _adjustStartColumnOffsetAfterHideColumn(sheet, i);
                changes.push.apply(changes, columnOffsetArray);
            }
        }
       
        var rowPage = sheetPageInfo.rowPage(), rowPage_repeatItemStart = rowPage.repeatItemStart(), rowPage_repeatItemEnd = rowPage.repeatItemEnd();
        var hiddenRowHeight = 0;
        if (rowPage_repeatItemStart !== -1 && rowPage_repeatItemEnd !== -1) {
            sheet.frozenRowCount(rowPage_repeatItemEnd + 1);
            length = rowPage_repeatItemStart;
            for (i = 0; i < length; i++) {
                changes.push({ type: "rowVisible", sheetName: sheet.name(), index: i, visible: sheet.getRowVisible(i) });
                sheet.setRowVisible(i, false);
                hiddenRowHeight += sheet._getActualRowHeight(i);
                var rowOffsetArray = _adjustStartRowOffsetAfterHideRow(sheet, i);
                changes.push.apply(changes, rowOffsetArray);
            }
        }
        if (sheet.shapes && (hiddenColWidth > 0 || hiddenRowHeight > 0)) {
            var shapeChanges = sheet.shapes._moveShapeForHideRowAndColumn(sheet, hiddenColWidth, hiddenRowHeight);
            changes.push.apply(changes, shapeChanges);
        }
       
        sheet.showCell(rowPage.itemStart(), columnPage.itemStart(), 0 , 0 );
        return changes;
    };
    _PrintPagePresenter.prototype._restoreSheet = function (changes) {
        var workbook = this._workbook;
        for (var i = changes.length - 1; i >= 0; i--) {
            var currentChange = changes[i], type = currentChange.type, index = currentChange.index, visible = currentChange.visible, floatingObject = currentChange.floatingObject, floatingObjectOffset = currentChange.floatingObjectOffset, offset = currentChange.offset, shape = currentChange.shape;
            var sheet = _getWorksheetFromName(workbook, currentChange.sheetName);
            if (type === "colVisible") {
                sheet.setColumnVisible(index, visible);
            }
            else if (type === "rowVisible") {
                sheet.setRowVisible(index, visible);
            }
            else if (type === "startRowOffset") {
                floatingObject.startRowOffset(floatingObjectOffset);
            }
            else if (type === "startColumnOffset") {
                floatingObject.startColumnOffset(floatingObjectOffset);
            }
            else if (type === "shapePosition") {
                shape.resize(offset.x, offset.y, shape.width(), shape.height());
            }
        }
    };
    _PrintPagePresenter.prototype._getImageLoader = function () {
        var self = this;
        if (!self._imageLoader) {
            self._imageLoader = new Core_1._ImageLoader(function () {
                if (self._imageLoader) {
                    self.build();
                }
            });
        }
        return self._imageLoader;
    };
    _PrintPagePresenter.prototype._preProcessCharts = function () {
        var self = this;
        if (!self._chartsProcessor) {
            var charts_1 = [];
            var paginator = self._paginator, sheets = paginator instanceof WorksheetPaginator ? [paginator._sheet] : self._workbook.sheets;
            sheets.forEach(function (sheet) {
                if (sheet.charts) {
                    sheet.charts.all().forEach(function (chart) {
                        if (chart.isVisible() && chart.canPrint()) {
                           
                            chart.useAnimation(false);
                            charts_1.push(chart);
                        }
                    });
                }
            });
            if (charts_1.length > 0) {
                self._chartsProcessor = new ChartsProcessor(charts_1);
                self._chartsProcessor._processAllCharts();
            }
        }
    };
    return _PrintPagePresenter;
}());
exports._PrintPagePresenter = _PrintPagePresenter;
var SpreadPrintLine =  (function () {
    function SpreadPrintLine() {
       
        this.printer = new _SpreadPrinter();
        this.isLayoutChanged = true;
        this.sheetName = keyword_null;
        this.cachePageInfo = keyword_null;
        this.printInfoString = JSON_stringify((new PrintInfo()).toJSON());
        this.cacheWorkbook = keyword_null;
    }
    SpreadPrintLine.prototype.dispose = function () {
        var self = this;
        if (self.printer) {
            self.printer.dispose();
            self.printer = keyword_null;
        }
        if (self.sheet) {
            self.unbindSheetEvent();
            self.sheet = keyword_null;
        }
        self.cachePageInfo = keyword_null;
        self.printInfoString = keyword_null;
        if (self.cacheWorkbook) {
            self.cacheWorkbook._dispose();
            self.cacheWorkbook = keyword_null;
        }
    };
    SpreadPrintLine.prototype.bindSheetEvent = function () {
        var self = this;
        self.sheet._bind(Core_1.Events.ColumnWidthChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
            self.sheet.repaint();
        });
        self.sheet._bind(Core_1.Events.ColumnChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.RowHeightChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
            self.sheet.repaint();
        });
        self.sheet._bind(Core_1.Events.RowChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.TableFiltered + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.RangeFiltered + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.TableFilterClearing + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.RangeFilterClearing + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
        });
        self.sheet._bind(Core_1.Events.RangeGroupStateChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
            self.sheet.repaint();
        });
        self.sheet._bind(Core_1.Events.OutlineColumnCheckStatusChanged + GC_PRINTLINE_NS, function () {
            self.isLayoutChanged = true;
            self.sheet.repaint();
        });
    };
    SpreadPrintLine.prototype.unbindSheetEvent = function () {
        var self = this;
        self.sheet._unbind(Core_1.Events.ColumnWidthChanged + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.ColumnChanged + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.RowHeightChanged + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.RowChanged + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.TableFiltered + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.RangeFiltered + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.TableFilterClearing + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.RangeFilterClearing + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.RangeGroupStateChanged + GC_PRINTLINE_NS);
        self.sheet._unbind(Core_1.Events.OutlineColumnCheckStatusChanged + GC_PRINTLINE_NS);
    };
    SpreadPrintLine.prototype.layoutChanged = function (sheet) {
        var self = this;
        var isSameSheet = (self.sheet && self.sheet.name()) === sheet.name();
        if (isSameSheet) {
            this.isLayoutChanged = true;
        }
    };
    SpreadPrintLine.prototype.setSheet = function (sheet) {
        var self = this, currentSheet = self.sheet;
        var isSameSheet = (currentSheet && currentSheet.name()) === sheet.name(), isPrintInfoEqual = self.printInfoString === JSON_stringify(sheet && sheet.printInfo().toJSON());
        if (isSameSheet && isPrintInfoEqual) {
            return;
        }
        if (currentSheet) {
            self.unbindSheetEvent();
        }
        self.sheet = sheet;
        self.bindSheetEvent();
    };
    SpreadPrintLine.prototype.isNeedReCalc = function (sheet) {
        var self = this;
        var isSheetEqual = self.sheetName === ((sheet && sheet.name()) || undefined), isLayoutEqual = self.isLayoutChanged === false, isPrintInfoEqual = self.printInfoString === JSON_stringify(sheet && sheet.printInfo().toJSON());
        return !(isSheetEqual && isLayoutEqual && isPrintInfoEqual);
    };
    SpreadPrintLine.prototype._attachContext = function (workbook, sheetIndex) {
        var self = this, newWorkbook = self.cacheWorkbook, sheet;
        if (!isUndefined(sheetIndex) && sheetIndex !== keyword_null) {
            sheet = workbook.sheets[sheetIndex];
        }
        if (newWorkbook && !self.isNeedReCalc(sheet)) {
            return newWorkbook;
        }
        if (newWorkbook) {
            newWorkbook._dispose();
        }
        newWorkbook = self.printer._attachContext(workbook);
        self.cacheWorkbook = newWorkbook;
        return newWorkbook;
    };
    SpreadPrintLine.prototype.pageInfo = function (originalWorkbook, newWorkbook, sheetIndex, isFromPrintLine) {
        var self = this, workbook = originalWorkbook, sheet;
        if (!isUndefined(sheetIndex) && sheetIndex !== keyword_null) {
            sheet = workbook.sheets[sheetIndex];
            self.setSheet(sheet);
        }
        if (!self.isNeedReCalc(sheet)) {
            return self.cachePageInfo;
        }
        var printer = self.printer, paginator;
        workbook = newWorkbook;
        if (isFromPrintLine) {
            workbook.suspendPaint();
            workbook.suspendEvent();
            var oldOptions = self.changeWorkbookOptions(workbook);
            var oldSheetOffset = self.changeSheetOffset(workbook);
            paginator = printer.calcPaginator(workbook, sheetIndex);
            workbook.options.scrollbarMaxAlign = oldOptions.scrollbarMaxAlign;
            workbook.options.scrollbarShowMax = oldOptions.scrollbarShowMax;
            workbook.options.scrollIgnoreHidden = oldOptions.scrollIgnoreHidden;
            self.appleOldSheetOffset(workbook, oldSheetOffset);
            workbook.resumePaint();
            workbook.resumeEvent();
        }
        else {
            paginator = printer.prepareContext(workbook, sheetIndex);
        }
        var pageCount = paginator._pageCount;
        var rows = self.getRows(paginator._rowPages);
        var columns = self.getColumns(paginator._columnPages);
        self.isLayoutChanged = false;
        self.printInfoString = JSON_stringify(sheet.printInfo().toJSON());
        if (sheet) {
            this.sheetName = sheet.name();
        }
        self.cachePageInfo = { pageCount: pageCount, rows: rows, columns: columns };
        return self.cachePageInfo;
    };
    SpreadPrintLine.prototype.changeWorkbookOptions = function (workbook) {
        var printWorkBookOptions = workbook.options;
        var result = {
            scrollbarMaxAlign: printWorkBookOptions.scrollbarMaxAlign,
            scrollbarShowMax: printWorkBookOptions.scrollbarShowMax,
            scrollIgnoreHidden: printWorkBookOptions.scrollIgnoreHidden
        };
        printWorkBookOptions.scrollbarMaxAlign = false;
        printWorkBookOptions.scrollbarShowMax = true;
        printWorkBookOptions.scrollIgnoreHidden = false;
        return result;
    };
    SpreadPrintLine.prototype.changeSheetOffset = function (workbook) {
        var oldSheetOffset = [];
        var sheetCount = _getWorksheetCount(workbook), newSheet;
        for (var start = 0; start < sheetCount; start++) {
            newSheet = _getWorksheet(workbook, start);
            oldSheetOffset.push(newSheet.options.sheetAreaOffset);
            if (newSheet.printInfo().showBorder()) {
                newSheet.options.sheetAreaOffset = { left: 0, top: 0 };
            }
            else {
                newSheet.options.sheetAreaOffset = { left: 2, top: 2 };
            }
        }
        return oldSheetOffset;
    };
    SpreadPrintLine.prototype.appleOldSheetOffset = function (workbook, oldSheetOffset) {
        var sheetCount = _getWorksheetCount(workbook), newSheet;
        for (var start = 0; start < sheetCount; start++) {
            newSheet = _getWorksheet(workbook, start);
            newSheet.options.sheetAreaOffset = oldSheetOffset[start];
        }
    };
    SpreadPrintLine.prototype.getRows = function (rowPages) {
        var rows = [];
        for (var i = 0; i < rowPages.length; i++) {
            var page = rowPages[i]._itemEnd;
            rows.push(page);
        }
        return rows;
    };
    SpreadPrintLine.prototype.getColumns = function (columnPages) {
        var columns = [];
        for (var i = 0; i < columnPages.length; i++) {
            var page = columnPages[i]._itemEnd;
            columns.push(page);
        }
        return columns;
    };
    return SpreadPrintLine;
}());
function _setActualSize(sheet, sheetPaginator, index, zoomFactor, isRow) {
    if (isRow) {
        var sheetRowHeight = sheet.getRowHeight(index), sheetPaginatorRowHeight = sheetPaginator._getRowHeight(index, 3) * zoomFactor;
        if (sheetRowHeight !== sheetPaginatorRowHeight) {
            sheet.setRowHeight(index, sheetPaginatorRowHeight);
        }
    }
    else {
        var sheetColWidth = sheet.getColumnWidth(index), sheetPaginatorColWidth = sheetPaginator._getColumnWidth(index, 3) * zoomFactor;
        if (sheetColWidth !== sheetPaginatorColWidth) {
            sheet.setColumnWidth(index, sheetPaginatorColWidth);
        }
    }
}
function _isShowHeader(showHeader, isSheetHeaderVisible) {
    return showHeader === 2  || showHeader === 3  || showHeader === 0  && isSheetHeaderVisible;
}

var _SpreadPrinter =  (function () {
    function _SpreadPrinter() {
    }
    _SpreadPrinter.prototype.print = function (workbook, sheetIndex) {
        var self = this;
        self.dispose();
        var contextWorkbook = self._attachContext(workbook);
        var paginator = self.prepareContext(contextWorkbook, sheetIndex);
        var presenter = new _PrintPagePresenter(contextWorkbook, paginator);
        self._presenter = presenter;
        presenter.onBuildCompleted = function () {
            var iframe = presenter._getIframe();
            var argus = {
                iframe: iframe,
                cancel: false
            };
            workbook._trigger('BeforePrint', argus);
            if (argus.cancel === true) {
                return;
            }
            presenter.print();
        };
        presenter.build();
    };
    _SpreadPrinter.prototype.calcPaginator = function (workbook, sheetIndex, originPaginator, isFirstCheck) {
        var self = this, sheet, paginator, outParam;
        do {
            if (!isNullOrUndefined(originPaginator)) {
                paginator = originPaginator;
                paginator._pageCount = 0;
            }
            else {
                if (isUndefined(sheetIndex) || sheetIndex === keyword_null) {
                    paginator = new WorkbookPaginator(workbook);
                }
                else {
                    outParam = {};
                    sheet = _getWorksheet(workbook, sheetIndex);
                    initPrintingSize(sheet, sheet.printInfo(), outParam);
                    paginator = new WorksheetPaginator(workbook, sheetIndex, outParam.paperSize, outParam.pageImageableArea);
                }
            }
            paginator.paginate();
        } while (!self._checkPaginateResult(paginator, workbook));
        self._checkFitPagesResult(workbook, paginator, !isFirstCheck);
        return paginator;
    };
    _SpreadPrinter.prototype._checkFitPagesResult = function (spread, paginator, isFirstCheck) {
        var self = this, pageCount = paginator.pageCount(), shouldSetColWidth = true, shouldSetRowHeight = true;
        for (var index = 0; index < pageCount; index++) {
            var sheetPageInfo = paginator.getPage(index), sheetIndex = sheetPageInfo.sheetIndex(), sheet = _getWorksheet(spread, sheetIndex), rowPageInfo = sheetPageInfo.rowPage(), columnPageInfo = sheetPageInfo.columnPage(), startRowIndex = rowPageInfo._itemStart, endRowIndex = rowPageInfo._itemEnd, repeatStartRowIndex = rowPageInfo._repeatItemStart, repeatEndRowIndex = rowPageInfo._repeatItemEnd, startColIndex = columnPageInfo._itemStart, endColIndex = columnPageInfo._itemEnd, repeatStartColIndex = columnPageInfo._repeatItemStart, repeatEndColIndex = columnPageInfo._repeatItemEnd;
            var sheetPaginator = paginator._sheetPaginators ? paginator._sheetPaginators[sheetIndex] : paginator;
            var printSettings = sheetPaginator._printSettings, fitPagesTall = printSettings.fitPagesTall(), fitPagesWide = printSettings.fitPagesWide();
            var horizontalZoomFactor = sheetPaginator._horizontalZoomFactor, verticalZoomFactor = sheetPaginator._verticalZoomFactor;
            var isFitPagesTall = fitPagesTall !== -1, isFitPagesWide = fitPagesWide !== -1;
           
           
           
            if (isFitPagesTall || isFitPagesWide) {
                var totalRowHeight = 0, totalColWidth = 0, newVerticalZoomFactor = 1, newHorizontalZoomFactor = 1;
                if (!sheetPaginator._ignoreHorizontalPaginate && !sheetPaginator._ignoreVerticalPaginate) {
                    var shouldJudgeWhenBothFit = isFitPagesWide && isFitPagesTall && (horizontalZoomFactor === 1 || verticalZoomFactor === 1);
                    if ((isFitPagesWide && !isFitPagesTall) || (shouldJudgeWhenBothFit && horizontalZoomFactor < verticalZoomFactor)) {
                        newVerticalZoomFactor = horizontalZoomFactor / verticalZoomFactor;
                        sheetPaginator.verticalZoomFactor(newVerticalZoomFactor);
                        sheetPaginator._ignoreHorizontalPaginate = true;
                        shouldSetRowHeight = false;
                    }
                    else if ((!isFitPagesWide && isFitPagesTall) || (shouldJudgeWhenBothFit && horizontalZoomFactor > verticalZoomFactor)) {
                        newHorizontalZoomFactor = verticalZoomFactor / horizontalZoomFactor;
                        sheetPaginator.horizontalZoomFactor(newHorizontalZoomFactor);
                        sheetPaginator._ignoreVerticalPaginate = true;
                        shouldSetColWidth = false;
                    }
                }
                if (shouldSetRowHeight && (isFirstCheck || !sheetPaginator._ignoreVerticalPaginate)) {
                    var showColumnHeader = printSettings.showColumnHeader();
                    if (_isShowHeader(showColumnHeader, sheet.options.colHeaderVisible)) {
                       
                        var colHeaderArea = 1, headerRowCount = sheet.getRowCount(colHeaderArea), totalHeaderRowHeight = 0;
                        for (var rowIndex = 0; rowIndex < headerRowCount; rowIndex++) {
                            var sheetHeaderRowHeight = sheet.getRowHeight(rowIndex, colHeaderArea), sheetPaginatorHeaderRowHeight = sheetPaginator._getRowHeight(rowIndex, colHeaderArea) * newVerticalZoomFactor;
                            if (sheetHeaderRowHeight !== sheetPaginatorHeaderRowHeight) {
                                sheet.setRowHeight(rowIndex, sheetPaginatorHeaderRowHeight, colHeaderArea);
                            }
                            totalHeaderRowHeight += sheet.getRowHeight(rowIndex, colHeaderArea);
                        }
                        rowPageInfo.headerSize(totalHeaderRowHeight);
                    }
                   
                    for (var rowIndex = startRowIndex; rowIndex <= endRowIndex; rowIndex++) {
                        _setActualSize(sheet, sheetPaginator, rowIndex, newVerticalZoomFactor, true );
                        totalRowHeight += sheet.getRowHeight(rowIndex, 3);
                    }
                   
                    if (repeatStartRowIndex !== -1 && repeatEndRowIndex >= repeatStartRowIndex) {
                        for (var rowIndex = repeatStartRowIndex; rowIndex <= repeatEndRowIndex; rowIndex++) {
                            if (rowIndex < startRowIndex || rowIndex > endRowIndex) {
                                _setActualSize(sheet, sheetPaginator, rowIndex, newVerticalZoomFactor, true );
                            }
                            totalRowHeight += sheet.getRowHeight(rowIndex, 3);
                        }
                    }
                   
                    rowPageInfo.contentSize(totalRowHeight);
                }
                if (shouldSetColWidth && (isFirstCheck || !sheetPaginator._ignoreHorizontalPaginate)) {
                    var showRowHeader = printSettings.showRowHeader();
                    if (_isShowHeader(showRowHeader, sheet.options.rowHeaderVisible)) {
                       
                        var rowHeaderArea = 2, headerColCount = sheet.getColumnCount(rowHeaderArea), totalHeaderColWidth = 0;
                        for (var colIndex = 0; colIndex < headerColCount; colIndex++) {
                            var sheetHeaderColWidth = sheet.getColumnWidth(colIndex, rowHeaderArea), sheetPaginatorHeaderColWidth = sheetPaginator._getColumnWidth(colIndex, rowHeaderArea) * newHorizontalZoomFactor;
                            if (sheetHeaderColWidth !== sheetPaginatorHeaderColWidth) {
                                sheet.setColumnWidth(colIndex, sheetPaginatorHeaderColWidth, rowHeaderArea);
                            }
                            totalHeaderColWidth += sheet.getColumnWidth(colIndex, rowHeaderArea);
                        }
                        columnPageInfo.headerSize(totalHeaderColWidth);
                    }
                   
                    for (var colIndex = startColIndex; colIndex <= endColIndex; colIndex++) {
                        _setActualSize(sheet, sheetPaginator, colIndex, newHorizontalZoomFactor, false );
                        totalColWidth += sheet.getColumnWidth(colIndex, 3);
                    }
                   
                    if (repeatStartColIndex !== -1 && repeatEndColIndex >= repeatStartColIndex) {
                        for (var colIndex = repeatStartColIndex; colIndex <= repeatEndColIndex; colIndex++) {
                            if (colIndex < startColIndex || colIndex > endColIndex) {
                                _setActualSize(sheet, sheetPaginator, colIndex, newHorizontalZoomFactor, false );
                            }
                            totalColWidth += sheet.getColumnWidth(colIndex, 3);
                        }
                    }
                    columnPageInfo.contentSize(totalColWidth);
                }
            }
        }
       
       
        if (isFirstCheck && (shouldSetColWidth === false || shouldSetRowHeight === false)) {
            self.calcPaginator(spread, keyword_null, paginator, isFirstCheck);
        }
    };
    _SpreadPrinter.prototype._attachContext = function (workbook) {
        var newWorkbook = new Core_1.Workbook();
        newWorkbook._isPrintWorkbook = true;
        newWorkbook.suspendPaint();
        newWorkbook.suspendEvent();
       
        var ignoreFormulas = true, count = _getWorksheetCount(workbook);
        for (var i = 0; i < count; i++) {
            if (_getWorksheet(workbook, i).options.showFormulas) {
                ignoreFormulas = false;
                break;
            }
        }
        newWorkbook.fromJSON(JSON_parse(JSON_stringify(workbook.toJSON({ includeBindingSource: true, ignoreFormula: ignoreFormulas, _isPrint: true, saveAsView: true, ignoreStarSize: true, includeAutoMergedCells: true }))));
       
       
        newWorkbook.sheets.forEach(function (sheet) {
            sheet.zoom(1);
        });
       
        var options = newWorkbook.options;
        options.scrollbarMaxAlign = false;
        options.scrollbarShowMax = true;
        options.scrollIgnoreHidden = false;
       
        var sheetCount = _getWorksheetCount(newWorkbook), newSheet;
        for (var start = 0; start < sheetCount; start++) {
            newSheet = _getWorksheet(newWorkbook, start);
            if (newSheet.printInfo().showBorder()) {
                newSheet.options.sheetAreaOffset = { left: 0, top: 0 };
            }
            else {
                newSheet.options.sheetAreaOffset = { left: 2, top: 2 };
            }
           
            var tableSheet = newSheet._parentSheet;
            if (tableSheet) {
                if (tableSheet.options.allowAddNew) {
                    var innerSheet = tableSheet._sheet;
                    innerSheet.deleteRows(innerSheet.getRowCount() - 1, 1);
                }
                if (tableSheet.actionColumn.options().visible) {
                    tableSheet._removeOperationColumn();
                }
            }
        }
        return newWorkbook;
    };
    _SpreadPrinter.prototype.prepareContext = function (newWorkbook, sheetIndex) {
        return this.calcPaginator(newWorkbook, sheetIndex);
    };
    _SpreadPrinter.prototype.dispose = function () {
        var presenter = this._presenter;
        if (presenter) {
            presenter.dispose();
        }
        this._presenter = keyword_null;
    };
    _SpreadPrinter.prototype._checkPaginateResult = function (paginator, spread) {
        var pageCount = paginator.pageCount();
        for (var index = 0; index < pageCount; index++) {
            var sheetPageInfo = paginator.getPage(index), preSheetPageInfo = void 0, sheetIndex = void 0, sheet = void 0;
            var rowPageInfo = sheetPageInfo.rowPage(), preRowPageInfo = void 0, zoomFactor = void 0;
            if (rowPageInfo.contentOffset() > 0 && index - 1 >= 0) {
                preSheetPageInfo = paginator.getPage(index - 1);
                preRowPageInfo = preSheetPageInfo.rowPage();
                sheetIndex = sheetPageInfo.sheetIndex();
                sheet = _getWorksheet(spread, sheetIndex);
                if (sheetIndex === preSheetPageInfo.sheetIndex()) {
                    zoomFactor = sheet._printInfo && sheet._printInfo._zoomFactor;
                    sheet.setRowHeight(preRowPageInfo.itemEnd(), Math.floor(rowPageInfo.contentOffset() / zoomFactor), 3 );
                    return false;
                }
            }
            var colPageInfo = sheetPageInfo.columnPage(), preColPageInfo = void 0;
            if (colPageInfo.contentOffset() > 0 && index - 1 >= 0) {
                preSheetPageInfo = paginator.getPage(index - 1);
                preColPageInfo = preSheetPageInfo.columnPage();
                sheetIndex = sheetPageInfo.sheetIndex();
                sheet = _getWorksheet(spread, sheetIndex);
                if (sheetIndex === preSheetPageInfo.sheetIndex()) {
                    zoomFactor = sheet._printInfo && sheet._printInfo._zoomFactor;
                    sheet.setColumnWidth(preColPageInfo.itemEnd(), Math.floor(colPageInfo.contentOffset() / zoomFactor), 3 );
                    return false;
                }
            }
        }
        return true;
    };
    return _SpreadPrinter;
}());
exports._SpreadPrinter = _SpreadPrinter;



/***/ }),

/***/ "./dist/plugins/print/print.ns.js":
/*!****************************************!*\
  !*** ./dist/plugins/print/print.ns.js ***!
  \****************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var en = __webpack_require__(/*! ./print.res.en */ "./dist/plugins/print/print.res.en.js");
exports.SR = {
    en: en
};


/***/ }),

/***/ "./dist/plugins/print/print.res.en.js":
/*!********************************************!*\
  !*** ./dist/plugins/print/print.res.en.js ***!
  \********************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.Exp_InvalidSheetIndex = 'Invalid  sheet index.';


/***/ }),

/***/ "Common":
/*!****************************!*\
  !*** external "GC.Spread" ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = GC.Spread;

/***/ }),

/***/ "Core":
/*!***********************************!*\
  !*** external "GC.Spread.Sheets" ***!
  \***********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = GC.Spread.Sheets;

/***/ })

/******/ });
//# sourceMappingURL=gc.spread.sheets.print.14.1.0.js.map
}));